Object subclass:#HTMLDocumentInterpreter
	instanceVariableNames:'document element'
	classVariableNames:'SelectorTable'
	poolDictionaries:''
	category:'System-Documentation'
!


!HTMLDocumentInterpreter  class methodsFor:'initialization'!

initialize
    SelectorTable isNil ifTrue:[
        SelectorTable := IdentityDictionary new.

        SelectorTable at:#'/title' put:#'titleEnd'.
        SelectorTable at:#'/head'  put:#'headEnd'.
        SelectorTable at:#'/body'  put:#'bodyEnd'.
        SelectorTable at:#'/html'  put:#'htmlEnd'.
        SelectorTable at:#'/plain' put:#'plainEnd'.

        SelectorTable at:#'/h1'    put:#'h1End'.
        SelectorTable at:#'/h2'    put:#'h2End'.
        SelectorTable at:#'/h3'    put:#'h3End'.
        SelectorTable at:#'/h4'    put:#'h4End'.
        SelectorTable at:#'/h5'    put:#'h5End'.
        SelectorTable at:#'/h6'    put:#'h6End'.

        SelectorTable at:#'/p'     put:#'pEnd'.

        SelectorTable at:#'/b'     put:#'bEnd'.
        SelectorTable at:#'/u'     put:#'uEnd'.
        SelectorTable at:#'/i'     put:#'iEnd'.
        SelectorTable at:#'/tt'    put:#'ttEnd'.
        SelectorTable at:#'/big'   put:#'bigEnd'.
        SelectorTable at:#'/small' put:#'smallEnd'.
        SelectorTable at:#'/sub'   put:#'subEnd'.
        SelectorTable at:#'/sup'   put:#'supEnd'.

        SelectorTable at:#'/address' put:#'addressEnd'.
        SelectorTable at:#'/abbrev'  put:#'abbrevEnd'.
        SelectorTable at:#'/acronym' put:#'acronymEnd'.
        SelectorTable at:#'/au'      put:#'auEnd'.
        SelectorTable at:#'/blockquote'  put:#'blockquoteEnd'.
        SelectorTable at:#'/cite'    put:#'citeEnd'.
        SelectorTable at:#'/code'    put:#'codeEnd'.
        SelectorTable at:#'/del'     put:#'delEnd'.
        SelectorTable at:#'/dfn'     put:#'dfnEnd'.
        SelectorTable at:#'/em'      put:#'emEnd'.
        SelectorTable at:#'/font'    put:#'fontEnd'.
        SelectorTable at:#'/ins'     put:#'insEnd'.
        SelectorTable at:#'/kbd'     put:#'kbdEnd'.
        SelectorTable at:#'/lang'    put:#'langEnd'.
        SelectorTable at:#'/person'  put:#'personEnd'.
        SelectorTable at:#'/q'       put:#'qEnd'.
        SelectorTable at:#'/s'       put:#'sEnd'.
        SelectorTable at:#'/samp'    put:#'sampEnd'.
        SelectorTable at:#'/strong'  put:#'strongEnd'.
        SelectorTable at:#'/var'     put:#'varEnd'.
        SelectorTable at:#'/blink'   put:#'blinkEnd'.
        SelectorTable at:#'/center'  put:#'centerEnd'.
        SelectorTable at:#'/nobr'    put:#'nobrEnd'.

        SelectorTable at:#'/a'       put:#'aEnd'.

        SelectorTable at:#'/ul'    put:#'ulEnd'.
        SelectorTable at:#'/menu'  put:#'menuEnd'.
        SelectorTable at:#'/dir'   put:#'dirEnd'.
        SelectorTable at:#'/dl'    put:#'dlEnd'.
        SelectorTable at:#'/ol'    put:#'olEnd'.
        SelectorTable at:#'/dd'    put:#'ddEnd'.
        SelectorTable at:#'/dt'    put:#'dtEnd'.
        SelectorTable at:#'/li'    put:#'liEnd'.

        SelectorTable at:#'/pre'    put:#'preEnd'.

        SelectorTable at:#'/caption'   put:#'captionEnd'.
        SelectorTable at:#'/table'     put:#'tableEnd'.
        SelectorTable at:#'/td'        put:#'tdEnd'.
        SelectorTable at:#'/tr'        put:#'trEnd'.
        SelectorTable at:#'/th'        put:#'thEnd'.

        SelectorTable at:#'/form'      put:#'formEnd'.
        SelectorTable at:#'/select'    put:#'selectEnd'.
        SelectorTable at:#'/textarea'  put:#'textareaEnd'.

        SelectorTable at:#'/map'       put:#'mapEnd'.

        SelectorTable at:#'/applet'         put:#'appletEnd'.
        SelectorTable at:#'/jwssuperapplet' put:#'jwssuperappletEnd'.
        SelectorTable at:#'/script'         put:#'scriptEnd'.

        SelectorTable at:#'/frameset'       put:#'framesetEnd'.
    ]

    "
     SelectorTable := nil.
     HTMLDocumentInterpreter initialize
    "

    "Modified: 5.9.1996 / 13:47:04 / cg"
! !

!HTMLDocumentInterpreter methodsFor:'elements - document'!

base

    "Created: 20.5.1996 / 22:17:53 / cg"
!

body

    "Created: 17.5.1996 / 15:00:04 / cg"
!

bodyEnd

    "Created: 17.5.1996 / 15:00:06 / cg"
!

frame

    "Created: 5.9.1996 / 13:47:47 / cg"
!

frameset

    "Created: 5.9.1996 / 13:47:29 / cg"
!

framesetEnd

    "Created: 5.9.1996 / 13:47:30 / cg"
!

head

    "Created: 17.5.1996 / 14:50:47 / cg"
!

headEnd

    "Created: 17.5.1996 / 14:55:36 / cg"
!

html

    "Created: 17.5.1996 / 14:49:02 / cg"
!

htmlEnd

    "Created: 17.5.1996 / 14:55:32 / cg"
!

link

    "Created: 18.6.1996 / 17:46:21 / cg"
!

title

    "Created: 17.5.1996 / 14:50:57 / cg"
!

titleEnd

    "Created: 17.5.1996 / 14:55:28 / cg"
! !

!HTMLDocumentInterpreter methodsFor:'elements - forms'!

form

    "Created: 17.5.1996 / 15:17:24 / cg"
!

formEnd

    "Created: 17.5.1996 / 15:20:22 / cg"
!

input

    "Created: 17.5.1996 / 15:20:19 / cg"
!

option

    "Created: 12.6.1996 / 18:47:58 / cg"
!

select

    "Created: 17.5.1996 / 15:20:26 / cg"
!

selectEnd

    "Created: 17.5.1996 / 15:20:27 / cg"
!

textarea

    "Created: 12.6.1996 / 18:47:48 / cg"
!

textareaEnd

    "Created: 12.6.1996 / 18:47:51 / cg"
! !

!HTMLDocumentInterpreter methodsFor:'elements - lists'!

dd

    "Created: 17.5.1996 / 15:04:16 / cg"
!

ddEnd

    "Created: 17.5.1996 / 15:04:18 / cg"
!

dir

    "Created: 20.5.1996 / 19:10:11 / cg"
!

dirEnd

    "Created: 20.5.1996 / 19:10:12 / cg"
!

dl

    "Created: 17.5.1996 / 15:04:13 / cg"
!

dlEnd

    "Created: 17.5.1996 / 15:04:15 / cg"
!

dt

    "Created: 17.5.1996 / 15:04:20 / cg"
!

dtEnd

    "Created: 17.5.1996 / 15:04:22 / cg"
!

li

    "Created: 17.5.1996 / 15:08:30 / cg"
!

liEnd

    "Created: 26.7.1996 / 18:14:23 / cg"
!

menu

    "Created: 20.5.1996 / 19:02:09 / cg"
!

menuEnd

    "Created: 20.5.1996 / 19:02:14 / cg"
!

ol

    "Created: 17.5.1996 / 15:04:11 / cg"
!

olEnd

    "Created: 17.5.1996 / 15:04:09 / cg"
!

ul

    "Created: 17.5.1996 / 15:04:06 / cg"
!

ulEnd

    "Created: 17.5.1996 / 15:04:07 / cg"
! !

!HTMLDocumentInterpreter methodsFor:'elements - special'!

a

    "Created: 17.5.1996 / 15:03:19 / cg"
!

aEnd

    "Created: 17.5.1996 / 15:03:20 / cg"
!

app

    "Created: 20.5.1996 / 22:30:53 / cg"
!

appEnd

    "Created: 20.5.1996 / 22:30:55 / cg"
!

applet

    "Created: 26.6.1996 / 09:14:10 / cg"
!

appletEnd

    "Created: 26.6.1996 / 09:14:08 / cg"
!

area

    "Created: 12.6.1996 / 18:52:30 / cg"
!

bgsound

    "Created: 5.9.1996 / 12:49:20 / cg"
!

img

    "Created: 17.5.1996 / 15:08:55 / cg"
!

jwssuperapplet

    "Created: 26.6.1996 / 09:14:16 / cg"
!

jwssuperappletEnd

    "Created: 26.6.1996 / 09:14:18 / cg"
!

map

    "Created: 12.6.1996 / 18:52:26 / cg"
!

mapEnd

    "Created: 12.6.1996 / 18:52:28 / cg"
!

script

    "Created: 30.6.1996 / 15:49:33 / cg"
!

scriptEnd

    "Created: 30.6.1996 / 15:49:34 / cg"
!

specialMarkup

    "Created: 17.5.1996 / 15:03:05 / cg"
! !

!HTMLDocumentInterpreter methodsFor:'elements - structure'!

br

    "Created: 17.5.1996 / 15:22:06 / cg"
!

h1

    "Created: 17.5.1996 / 15:00:15 / cg"
!

h1End

    "Created: 17.5.1996 / 15:00:16 / cg"
!

h2

    "Created: 17.5.1996 / 15:00:18 / cg"
!

h2End

    "Created: 17.5.1996 / 15:00:19 / cg"
!

h3

    "Created: 17.5.1996 / 15:00:21 / cg"
!

h3End

    "Created: 17.5.1996 / 15:00:23 / cg"
!

h4

    "Created: 17.5.1996 / 15:00:25 / cg"
!

h4End

    "Created: 17.5.1996 / 15:00:27 / cg"
!

h5

    "Created: 17.5.1996 / 15:00:29 / cg"
!

h5End

    "Created: 17.5.1996 / 15:00:30 / cg"
!

h6

    "Created: 17.5.1996 / 15:00:32 / cg"
!

h6End

    "Created: 17.5.1996 / 15:00:34 / cg"
!

hr

    "Created: 17.5.1996 / 15:08:45 / cg"
!

nobr

    "Created: 12.7.1996 / 11:05:02 / cg"
!

nobrEnd

    "Created: 12.7.1996 / 11:05:05 / cg"
!

p

    "Created: 17.5.1996 / 15:01:42 / cg"
!

pEnd

    "Created: 17.5.1996 / 15:01:43 / cg"
!

plain

    "Created: 20.5.1996 / 19:40:11 / cg"
!

plainEnd

    "Created: 20.5.1996 / 19:40:13 / cg"
!

pre

    "Created: 17.5.1996 / 15:21:18 / cg"
!

preEnd

    "Created: 17.5.1996 / 15:21:19 / cg"
!

tab

    "Created: 18.6.1996 / 21:25:42 / cg"
!

wbr

    "Created: 18.6.1996 / 21:23:31 / cg"
! !

!HTMLDocumentInterpreter methodsFor:'elements - style'!

abbrev

    "Created: 17.5.1996 / 15:09:12 / cg"
!

abbrevEnd

    "Created: 17.5.1996 / 15:09:14 / cg"
!

acronym

    "Created: 17.5.1996 / 15:09:17 / cg"
!

acronymEnd

    "Created: 17.5.1996 / 15:09:19 / cg"
!

address

    "Created: 17.5.1996 / 15:09:06 / cg"
!

addressEnd

    "Created: 17.5.1996 / 15:09:07 / cg"
!

au

    "Created: 17.5.1996 / 15:09:22 / cg"
!

auEnd

    "Created: 17.5.1996 / 15:09:23 / cg"
!

blink

    "Created: 17.5.1996 / 15:10:49 / cg"
!

blinkEnd

    "Created: 17.5.1996 / 15:10:50 / cg"
!

blockquote

    "Created: 17.5.1996 / 15:09:27 / cg"
!

blockquoteEnd

    "Created: 17.5.1996 / 15:09:29 / cg"
!

center

    "Created: 17.5.1996 / 15:10:54 / cg"
!

centerEnd

    "Created: 17.5.1996 / 15:10:55 / cg"
!

cite

    "Created: 17.5.1996 / 15:01:51 / cg"
!

citeEnd

    "Created: 17.5.1996 / 15:01:52 / cg"
!

code

    "Created: 17.5.1996 / 15:09:34 / cg"
!

codeEnd

    "Created: 17.5.1996 / 15:09:35 / cg"
!

del

    "Created: 17.5.1996 / 15:09:43 / cg"
!

delEnd

    "Created: 17.5.1996 / 15:09:44 / cg"
!

dfn

    "Created: 17.5.1996 / 15:09:46 / cg"
!

dfnEnd

    "Created: 17.5.1996 / 15:09:48 / cg"
!

em

    "Created: 17.5.1996 / 15:09:52 / cg"
!

emEnd

    "Created: 17.5.1996 / 15:09:53 / cg"
!

font

    "Created: 12.6.1996 / 17:12:18 / cg"
!

fontEnd

    "Created: 12.6.1996 / 17:12:19 / cg"
!

ins

    "Created: 17.5.1996 / 15:09:58 / cg"
!

insEnd

    "Created: 17.5.1996 / 15:09:59 / cg"
!

kbd

    "Created: 17.5.1996 / 15:10:03 / cg"
!

kbdEnd

    "Created: 17.5.1996 / 15:10:04 / cg"
!

lang

    "Created: 17.5.1996 / 15:10:07 / cg"
!

langEnd

    "Created: 17.5.1996 / 15:10:08 / cg"
!

person

    "Created: 17.5.1996 / 15:10:14 / cg"
!

personEnd

    "Created: 17.5.1996 / 15:10:15 / cg"
!

q

    "Created: 17.5.1996 / 15:10:26 / cg"
!

qEnd

    "Created: 17.5.1996 / 15:10:28 / cg"
!

s

    "Created: 17.5.1996 / 15:10:30 / cg"
!

sEnd

    "Created: 17.5.1996 / 15:10:32 / cg"
!

samp

    "Created: 17.5.1996 / 15:10:36 / cg"
!

sampEnd

    "Created: 17.5.1996 / 15:10:37 / cg"
!

strong

    "Created: 17.5.1996 / 15:10:40 / cg"
!

strongEnd

    "Created: 17.5.1996 / 15:10:41 / cg"
!

var

    "Created: 17.5.1996 / 15:10:45 / cg"
!

varEnd

    "Created: 17.5.1996 / 15:10:46 / cg"
! !

!HTMLDocumentInterpreter methodsFor:'elements - style physical'!

b

    "Created: 17.5.1996 / 15:11:11 / cg"
!

bEnd

    "Created: 17.5.1996 / 15:11:12 / cg"
!

big

    "Created: 17.5.1996 / 15:11:30 / cg"
!

bigEnd

    "Created: 17.5.1996 / 15:11:31 / cg"
!

i

    "Created: 17.5.1996 / 15:11:15 / cg"
!

iEnd

    "Created: 17.5.1996 / 15:11:17 / cg"
!

small

    "Created: 17.5.1996 / 15:11:33 / cg"
!

smallEnd

    "Created: 17.5.1996 / 15:11:35 / cg"
!

sub

    "Created: 17.5.1996 / 15:11:38 / cg"
!

subEnd

    "Created: 17.5.1996 / 15:11:39 / cg"
!

sup

    "Created: 17.5.1996 / 15:11:41 / cg"
!

supEnd

    "Created: 17.5.1996 / 15:11:43 / cg"
!

tt

    "Created: 17.5.1996 / 15:11:26 / cg"
!

ttEnd

    "Created: 17.5.1996 / 15:11:28 / cg"
!

u

    "Created: 17.5.1996 / 15:11:22 / cg"
!

uEnd

    "Created: 17.5.1996 / 15:11:24 / cg"
! !

!HTMLDocumentInterpreter methodsFor:'elements - tables'!

caption

    "Created: 18.6.1996 / 21:14:10 / cg"
!

captionEnd

    "Created: 18.6.1996 / 21:14:11 / cg"
!

table

    "Created: 12.6.1996 / 17:33:41 / cg"
!

tableEnd

    "Created: 12.6.1996 / 17:33:43 / cg"
!

td

    "Created: 12.6.1996 / 17:34:20 / cg"
!

tdEnd

    "Created: 18.6.1996 / 23:47:01 / cg"
!

th

    "Created: 18.6.1996 / 18:09:06 / cg"
!

thEnd

    "Created: 18.6.1996 / 18:09:11 / cg"
!

tr

    "Created: 12.6.1996 / 17:34:19 / cg"
!

trEnd

    "Created: 18.6.1996 / 18:09:03 / cg"
! !

!HTMLDocumentInterpreter methodsFor:'processing'!

process:aDocument

    document := aDocument.

    aDocument do:[:e |
        |type|

        element := e.
        type := e type.
        type isNil ifTrue:[
            self specialMarkup
        ] ifFalse:[
            type := SelectorTable at:type ifAbsent:type.
            (type endsWith:$/) ifFalse:[
"/            self perform:type ifNotUnderstood:[].
                self perform:type
            ]
        ]
    ]

    "Created: 17.5.1996 / 14:56:23 / cg"
    "Modified: 18.6.1996 / 21:12:55 / cg"
! !

!HTMLDocumentInterpreter  class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic3/Attic/HTMLDocumentInterpreter.st,v 1.17 1996-09-05 17:52:26 cg Exp $'
! !
HTMLDocumentInterpreter initialize!
