HTMLDocumentInterpreter subclass:#HTMLDocumentPainter
	instanceVariableNames:'destination x y fontHeight fontAscent fontAvgHeight codeFont
		normalFont boldNormalFont italicNormalFont boldItalicNormalFont
		boldCodeFont italicCodeFont boldItalicCodeFont h1Font h2Font
		h3Font h4Font h5Font h6Font normalSmallFont leftIndent
		indentOffset rightIndent docWidth wSpace collectingText
		normalFontHeight textFGColor anchorFGColor activeAnchorFGColor
		activeAnchorBGColor visitedAnchorFGColor exampleFGColor yNextLine
		maxWidth maxHeight anchorElement collectedText anchors
		boundsCollector previousIsEmpty inPre inDL inOL inBLOCKQUOTE
		formatting scanning displayTop displayBottom displayLeft
		displayRight yText underline strikeout liStack ulLevel
		strongLevel emLevel boldLevel italicLevel needFontChange
		needColorChange currentColor currentFont inSup hBegin syncPoints
		elementIndex forms widgets currentForm fixFontWidth
		currentTextAreaElement currentTable noBreak maps inHeader
		metaCommands subProcesses currentMap currentRowIndex
		currentColIndex imageDisplayProcess imagesToDisplay imagesToLoad
		tabulators lastTextX pageOffsetY needSpace topMargin leftMargin
		rightMargin imageAndStyleResolver listOfHeaders
		arrayOfHeaderIndex headerDefinition pageNumber formattingStyle'
	classVariableNames:'ULindent DLindent OLindent BLOCKQUOTEindent SUPshift SUBshift'
	poolDictionaries:''
	category:'System-Documentation'
!


!HTMLDocumentPainter  class methodsFor:'initialization'!

initialize
    ULindent := 40.
    DLindent := 40.
    OLindent := 40.
    BLOCKQUOTEindent := 40.
    SUPshift := 4.

    "
     self initialize
    "

    "Created: 22.6.1996 / 16:48:59 / cg"
    "Modified: 19.7.1996 / 14:25:19 / cg"
! !

!HTMLDocumentPainter methodsFor:'accessing - private'!

currentColIndex
    ^ currentColIndex

    "Created: 22.6.1996 / 16:48:59 / cg"
!

currentColor
    ^ currentColor

    "Created: 22.6.1996 / 16:48:59 / cg"
!

currentFont
    ^ currentFont

    "Created: 22.6.1996 / 16:48:59 / cg"
!

currentFontAscent
    ^ fontAscent

    "Created: 22.6.1996 / 16:48:59 / cg"
!

currentFontAvgHeight
    ^ fontAvgHeight

    "Created: 22.6.1996 / 16:48:59 / cg"
!

currentFontHeight
    ^ fontHeight

    "Created: 22.6.1996 / 16:48:59 / cg"
!

currentForm
    ^ currentForm

    "Created: 22.6.1996 / 16:48:59 / cg"
!

currentIndentOffset
    ^ indentOffset

    "Created: 22.6.1996 / 16:48:59 / cg"
!

currentLeftIndent
    ^ leftIndent

    "Created: 22.6.1996 / 16:48:59 / cg"
!

currentRightIndent
    ^ rightIndent

    "Created: 22.6.1996 / 16:48:59 / cg"
!

currentRowIndex
    ^ currentRowIndex

    "Created: 22.6.1996 / 16:48:59 / cg"
!

currentTable
    ^ currentTable

    "Created: 22.6.1996 / 16:48:59 / cg"
!

document:aDocument
    document := aDocument

    "Created: 22.6.1996 / 16:48:59 / cg"
!

elementIndex
    ^ elementIndex

    "Created: 22.6.1996 / 16:48:59 / cg"
!

hBegin
    ^ hBegin

    "Created: 22.6.1996 / 16:48:59 / cg"
!

inBLOCKQUOTE
    ^ inBLOCKQUOTE

    "Created: 22.6.1996 / 16:48:59 / cg"
!

inDL
    ^ inDL

    "Modified: 21.5.1996 / 21:30:37 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

inNoBreak
    ^ noBreak

    "Created: 22.6.1996 / 16:48:59 / cg"
!

inOL
    ^ inOL

    "Created: 22.6.1996 / 16:48:59 / cg"
!

inPre
    ^ inPre

    "Created: 22.6.1996 / 16:48:59 / cg"
!

inStrikeout
    ^ strikeout

    "Created: 22.6.1996 / 16:48:59 / cg"
!

inSup
    ^ inSup

    "Created: 22.6.1996 / 16:48:59 / cg"
!

inUnderline
    ^ underline

    "Created: 22.6.1996 / 16:48:59 / cg"
!

previousIsEmpty
    ^ previousIsEmpty

    "Created: 22.6.1996 / 16:48:59 / cg"
!

ulLevel
    ^ ulLevel

    "Created: 22.6.1996 / 16:48:59 / cg"
!

xPosition
    ^ x

    "Modified: 21.5.1996 / 21:33:44 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

yNextLine
    ^ yNextLine

    "Created: 22.6.1996 / 16:48:59 / cg"
!

yPosition
    ^ y

    "Created: 22.6.1996 / 16:48:59 / cg"
!

yText
    ^ yText

    "Modified: 21.5.1996 / 21:30:11 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
! !

!HTMLDocumentPainter methodsFor:'contents'!

contentsAddHeader:text
    "assign text to header and store in list of headers
    "
    |hdef index|

    hdef := text withoutSeparators.

    (hdef notNil and:[hBegin notNil]) ifFalse:[
        ^ text
    ].

    headerDefinition notEmpty ifTrue:[
        headerDefinition := headerDefinition, ' ', hdef.
        ^ text
    ].

    headerDefinition := hdef.
    index := hBegin type asString last digitValue.
    hdef  := self headerAsString:arrayOfHeaderIndex depht:index.
  ^ hdef, ' ', text withoutLeadingSeparators

!

headerAsString:anArray depht:depth
    "returns printable header assigned to array
    "
    |header|

    header := ''.

    1 to:depth do:[:i|
        header := header, (anArray at:i) printString, '.'
    ].
"/    ^ header copyWithoutLast:1
    ^ header

    "Modified: 7.9.1996 / 18:13:17 / cg"
!

printContents
    |saveY hdrs indent indent2 indents pageX endPageOfCont
     chapterLevel subChapterLevel|

    ((destination isView) or:[listOfHeaders isNil]) ifTrue:[
        ^ self
    ].

    chapterLevel := 1.
    subChapterLevel := 2.

    destination pageStartAction:[:pageNr | 
                                        destination pageName:(self romanStringFor:pageNr)
                                ].

    hdrs := self initialHeaderNumbers.
    saveY  := y.
    endPageOfCont := 0.
    element type:nil.

    self setFont:h1Font.
    element text:'Contents'.
    self specialMarkup.
    self break.
    self setFont:normalFont.

    indent  := currentFont widthOf:(String new:10 withAll:$w).
    indent2 := indent // 5.
    indents := (1 to:6) collect:[:i | indent + ((i-1)*indent2)].

    indent2 := indent // 5.
    pageX  := docWidth-rightIndent 
              - (currentFont widthOf:(String new:4 withAll:$w)).

    destination pageEndAction:([:pageNr||s cY cX|
        s  := self romanStringFor:pageNr.
        cY := destination bottomMargin // 2.
        cX := (destination width)
            - ((destination titleFont) widthOf:s)
            - rightMargin.
        endPageOfCont := pageNr.

        destination displayString:s x:(destination transformX:cX) y:cY.
        s := destination title.
        s notNil ifTrue:[
            destination displayString:s x:(destination transformX:0) y:cY
        ].
    ]).
        
    listOfHeaders do:[:el|
        |text page headerLevel string|

        headerLevel := el at:1.
        page  := el at:2.
        text  := el at:3.

        hdrs at:headerLevel put:((hdrs at:headerLevel) + 1).
        (headerLevel + 1) to:hdrs size do:[:i|hdrs at:i put:0].

        indent := indents at:headerLevel.

        headerLevel == chapterLevel ifTrue:[
             indentOffset := indent.
             self break.
             self break.
             self setFont:boldNormalFont.
             text := 'Chapter ', (hdrs at:1) printString, ':  ', text.
        ] ifFalse:[
             headerLevel == subChapterLevel ifTrue:[
                self break.
             ].
             element text:(self headerAsString:hdrs depht:headerLevel).
             self specialMarkup.
             x < indent ifTrue:[
                 lastTextX := nil.
                 x := indent
             ].
        ].
        
        element text:text.
        self specialMarkup.
        lastTextX := nil.
        x > pageX ifTrue:[
            self break
        ].
        x := pageX.
        lastTextX := nil.

        element text:(page printString).
        self specialMarkup.
        indentOffset := 0.
        self break.

        headerLevel == chapterLevel ifTrue:[
            self setFont:normalFont.
            self break.
        ]
    ].

    destination pageStartAction:[:pageNr | 
                                    destination 
                                        pageName:(pageNr - endPageOfCont) printString
                                ].
    destination startPage.

    lastTextX := nil.
    previousIsEmpty := false.
    y               := saveY.
    indentOffset    := 0.

    destination pageEndAction:([:pageNr||s cY cX|
        s  := 'page ' , (pageNr - endPageOfCont) printString.
        cY := destination bottomMargin // 2.
        cX := (destination width)
            - ((destination titleFont) widthOf:s)
            - rightMargin.

        destination displayString:s x:(destination transformX:cX) y:cY.
        s := destination title.
        s notNil ifTrue:[
            destination displayString:s x:(destination transformX:0) y:cY
        ].
    ]).

    "Modified: 7.9.1996 / 19:15:47 / cg"
! !

!HTMLDocumentPainter methodsFor:'displaying'!

displayX:xLeft y:yTop width:w height:h on:aGC
    |xV yV|

    document isNil ifTrue:[
        ^ self
    ].

    "/ first look, if this is an expose for any widget;
    "/ if so, ignore it.

    widgets notNil ifTrue:[
        xV := xLeft - destination viewOrigin x.
        yV := yTop - destination viewOrigin y.

        widgets do:[:widget |
            |v|

            v := widget view.
            v notNil ifTrue:[
                (xLeft == v origin x
                and:[yTop == v origin y
                and:[w == v width
                and:[h == v height]]]) ifTrue:[
                    ^ self.
                ]
            ]
        ].
    ].

    self hideWidgets.

    displayTop := yTop.
    displayBottom := yTop + h - 1.
    displayLeft := xLeft.
    displayRight := xLeft + w - 1.

    destination := aGC.
    formatting := scanning := false.

    leftIndent := leftMargin.
    rightIndent := rightMargin.
    indentOffset := 0.

    needFontChange := needColorChange := true.
    self setFont:normalFont.
    normalFontHeight := fontAvgHeight.

    lastTextX := nil.
    x := leftIndent.
    y := topMargin + fontAscent.

    collectingText := inPre := 0.
    ulLevel := inDL := inOL := inBLOCKQUOTE := 0.
    underline := strikeout := inSup := 0.

    currentColor := textFGColor.
    needColorChange := true.    

    yNextLine := nil.

    formatting := scanning := false.
    previousIsEmpty := false.
    liStack := OrderedCollection new.

    anchorElement := hBegin := nil.

"/ MessageTally spyDetailedOn:[
    self redrawDocument.
"/ ].

    self showWidgets.

"/    self conditionalBreak.

    "Created: 22.6.1996 / 16:48:59 / cg"
    "Modified: 5.9.1996 / 21:44:18 / cg"
!

pageBreak
    (y > self pageBreakLimit and:[self atLeft and:[destination isView not]]) ifTrue:[
        formatting ifFalse:[
            destination startPage
        ] ifTrue:[
            pageNumber := pageNumber + 1
        ].

        lastTextX := nil.
        previousIsEmpty := true.
        y := destination topMargin. 
    ].

    "Modified: 7.9.1996 / 17:04:50 / cg"
!

pageBreakLimit
    ^ destination height
!

redrawDocument
    |previousMarkup startIndex syncPoint displayHeight pageLimit|

    displayHeight := 9999999.

    destination isView ifFalse:[
        displayHeight := destination height.
    ].

    "/ find a synchronization point

    syncPoints size == 0 ifTrue:[
        startIndex := 0
    ] ifFalse:[
        startIndex := syncPoints findFirst:[:p | p yPosition >= displayTop].
        startIndex := startIndex - 1.
        startIndex > 0 ifTrue:[
            syncPoint := syncPoints at:startIndex
        ]
    ].

    syncPoint notNil ifTrue:[
        "/ fetch the state found there
        self resyncFrom:syncPoint.
        startIndex := elementIndex.
    ] ifFalse:[
        startIndex := 1.
    ].

    pageLimit := self pageBreakLimit.

    self printContents.

    document from:startIndex to:document size do:[:e |
        |type top|

        element := e.
        type := e type.
        type isNil ifTrue:[
            self specialMarkup
        ] ifFalse:[
            type := SelectorTable at:type ifAbsent:type.
"/            self perform:type ifNotUnderstood:[].
            self perform:type
        ].

"CLAUS"
"/        (y > pageLimit and:[self atLeft and:[destination isView not]]) ifTrue:[
"/            self pageBreak
"/        ].
        
        y > (displayBottom+fontHeight) ifTrue:[
            ^ self
        ].

"/        ((top := element boundsTop) notNil
"/        and:[top > displayBottom]) ifTrue:[^ self].
    ].

    "Created: 22.6.1996 / 16:48:59 / cg"
    "Modified: 5.9.1996 / 22:24:09 / cg"
! !

!HTMLDocumentPainter methodsFor:'elements - document'!

body
    |bg img clr lM tM rM|

    lM := element numericParameterFor:'leftmargin' default:leftMargin.
    lM ~~ leftMargin ifTrue:[
        leftIndent := leftIndent - leftMargin + lM.
        x := x - leftIndent - leftMargin + lM.
        leftMargin := lM.
    ].
    tM := element numericParameterFor:'topmargin' default:topMargin.
    tM ~~ topMargin ifTrue:[
        y := y - topMargin + tM.
        topMargin := tM.
    ].
    rM := element numericParameterFor:'rightmargin' default:rightMargin.
    rM ~~ rightMargin ifTrue:[
        rightIndent := rightIndent - rightMargin + rM.
        rightMargin := rM.
    ].

    destination isView ifTrue:[
        bg := element parameterFor:'BACKGROUND'.
        bg notNil ifTrue:[
            img := imageAndStyleResolver imageFor:bg now:true.
        ].

        img notNil ifTrue:[
            destination viewBackground:(img asFormOn:destination device).
        ] ifFalse:[
            clr := element colorParameter:'BGCOLOR'.
            clr notNil ifTrue:[
               destination viewBackground:clr
            ] ifFalse:[
                destination viewBackground:destination defaultViewBackgroundColor
            ]
        ].
    ].

    clr := element colorParameter:'TEXT'.
    clr notNil ifTrue:[  
        textFGColor := clr
    ].

    clr := element colorParameter:'LINK'.
    clr notNil ifTrue:[
        anchorFGColor := clr
    ].

    clr := element colorParameter:'VLINK'.
    clr notNil ifTrue:[
        visitedAnchorFGColor := clr
    ].

    clr := element colorParameter:'ALINK'.
    clr notNil ifTrue:[
        activeAnchorFGColor := clr
    ].

    "Created: 22.6.1996 / 16:48:59 / cg"
    "Modified: 5.9.1996 / 21:33:46 / cg"
!

head
    scanning ifTrue:[
        inHeader := true
    ]

    "Created: 22.6.1996 / 16:48:59 / cg"
!

headEnd
    scanning ifTrue:[
        inHeader := false
    ]

    "Created: 22.6.1996 / 16:48:59 / cg"
!

link

    "Created: 22.6.1996 / 16:48:59 / cg"
!

meta
    |metaCommand metaArg args time|

    (scanning and:[inHeader]) ifTrue:[
        metaCommand := element parameterFor:'HTTP-EQUIV'.
        metaCommand notNil ifTrue:[
            (metaCommand := metaCommand asLowercase) = 'refresh' ifTrue:[
                metaArg := element parameterFor:'CONTENT'.
                metaArg notNil ifTrue:[
                    metaCommands isNil ifTrue:[
                        metaCommands := OrderedCollection new.
                    ].
                    metaCommands add:(metaCommand -> metaArg).
                    ^ self.
                ]
            ].
            ('HTML: unrecognized meta/args: ' , metaCommand) infoPrintCR
        ]
    ]

    "Modified: 12.6.1996 / 19:42:02 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

title
    collectingText := collectingText + 1.
    scanning ifTrue:[
        collectedText := ''
    ]

    "Modified: 24.5.1996 / 15:57:18 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

titleEnd
    collectingText > 0 ifTrue:[
        collectingText := collectingText - 1.
        scanning ifTrue:[
            collectedText notNil ifTrue:[
                destination title:collectedText.
            ].
            collectedText := nil.
        ]
    ] ifFalse:[
        scanning ifTrue:[
            'HTML: /TITLE but not within TITLE tag' errorPrintCR
        ]
    ]

    "Created: 22.6.1996 / 16:48:59 / cg"
    "Modified: 26.6.1996 / 09:11:28 / cg"
! !

!HTMLDocumentPainter methodsFor:'elements - forms'!

form
    currentForm notNil ifTrue:[
        'HTML: form within form - ignored' infoPrintCR.
    ] ifFalse:[
        destination isView ifTrue:[
            yNextLine := y + element maxHeight + 3.
        ].
        self conditionalBreak.
        currentForm := element.
    ]

    "Modified: 23.5.1996 / 09:25:37 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

formEnd
    scanning ifTrue:[
        currentTextAreaElement notNil ifTrue:[
            'HTML: unterminated textarea' infoPrintCR.
            self textareaEnd.
        ]
    ].

    self conditionalBreak.

    scanning ifTrue:[
        self fixupForm:currentForm.
    ].
    currentForm := nil

    "Modified: 24.5.1996 / 18:56:12 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

input
    self anyFormElement:element

    "Modified: 24.5.1996 / 16:09:00 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

textarea
    collectingText := collectingText + 1.
    currentTextAreaElement := element.
    scanning ifTrue:[
        collectedText := ''
    ].

    "Modified: 24.5.1996 / 16:13:00 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

textareaEnd
    collectingText := collectingText - 1.
    self anyFormElement:currentTextAreaElement.
    scanning ifTrue:[
        currentTextAreaElement view contents:collectedText.
    ].
    currentTextAreaElement := nil.

    "Modified: 24.5.1996 / 16:12:49 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
! !

!HTMLDocumentPainter methodsFor:'elements - lists'!

blockquote
    self conditionalEmpty.

    leftIndent := leftIndent + BLOCKQUOTEindent.
    x := x + BLOCKQUOTEindent.  lastTextX := nil.
    inBLOCKQUOTE := inBLOCKQUOTE + 1.

    "Modified: 21.5.1996 / 12:31:56 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

blockquoteEnd
    self conditionalEmpty.

    inBLOCKQUOTE := inBLOCKQUOTE - 1.
    inBLOCKQUOTE < 0 ifTrue:[
        'HTML: </blockquote> does not match any <blockquote>' errorPrintCR.
        inBLOCKQUOTE := 0.
    ] ifFalse:[
        leftIndent := leftIndent - BLOCKQUOTEindent.
        x := x - BLOCKQUOTEindent.  lastTextX := nil.
    ].

    "Modified: 21.5.1996 / 11:28:48 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

dd
    self conditionalBreak.

    "Modified: 20.5.1996 / 22:14:25 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

dir
    self ul.
    element markerType isNil ifTrue:[
        element markerType:'disc'.
    ]

    "Modified: 18.6.1996 / 22:44:18 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

dirEnd
    self ulEnd

    "Created: 22.6.1996 / 16:48:59 / cg"
!

dl
    self conditionalBreak.
    leftIndent := leftIndent + DLindent.
    x := x + DLindent.  lastTextX := nil.

    inDL == 0 ifTrue:[
        previousIsEmpty ifFalse:[
            self break
        ]
    ].
    formatting ifTrue:[
        liStack add:element.
    ].
    inDL := inDL + 1.

    "Modified: 18.6.1996 / 22:19:13 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

dlEnd
    self conditionalBreak.

    inDL := inDL - 1.
    inDL < 0 ifTrue:[
        'HTML: </dl> does not match any <dl>' errorPrintCR.
        inDL := 0.
    ] ifFalse:[
        leftIndent := leftIndent - DLindent.
        x := x - DLindent.  lastTextX := nil.
        formatting ifTrue:[
            liStack removeLast
        ]
    ].

    inDL == 0 ifTrue:[
        self conditionalEmpty.
    ]

    "Modified: 18.6.1996 / 22:09:21 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

dt
    |xL yT|

    self conditionalBreak.
    inDL == 0 ifTrue:[
        scanning ifTrue:[
            'HTML: <dt> but not within <dl> ... </dl>' infoPrintCR.
        ]
    ] ifFalse:[
        x := x - DLindent
    ].

    "Created: 22.6.1996 / 16:48:59 / cg"
    "Modified: 5.9.1996 / 12:37:52 / cg"
!

li
    |xL yT listElement nrDefinition nr nrType nrString letterRange letterStart
     marker|

    self conditionalBreak.
    previousIsEmpty := false.

    liStack isEmpty ifTrue:[

        'HTML: <li> but not within a list' infoPrintNL.
        ^ self
    ].

    "/ when reformatted, <li> markup is changed into either
    "/ <li_ul> or <li_ol>.
    "/ when displayed, <li> is never encountered ..

    formatting ifFalse:[
        self halt:'cannot happen'.
        ^ self.
    ].

    listElement := liStack last.
    listElement isNil ifTrue:[self halt].

    element markerType:(marker := listElement markerType).


    nr := listElement nextNumber.
    nr isNil ifTrue:[
        "/ in <ul> ... </ul>
        "/ draw a bullet

        (marker = 'disc' 
        or:[marker = 'arrow']) ifTrue:[
            xL := x - 16 - 4
        ] ifFalse:[
            xL := x - 10 - 4.
        ].
        yT := y - (fontAscent//2) + 1 - 3.

        element type:#'li_ul'.
        element nr:ulLevel.
        element origin:(xL @ yT).
        ^ self
    ].

    nrType := listElement numberType.

    letterRange := $Z asciiValue - $A asciiValue + 1.
    nrType == #uppercaseLetters ifTrue:[
        letterStart := $A
    ] ifFalse:[
        nrType == #lowercaseLetters ifTrue:[
            letterStart := $a
        ] ifFalse:[
            nrString := nr printString.
        ]
    ].

    letterStart notNil ifTrue:[
        nr := nr - 1.
        nr >= letterRange ifTrue:[
            nrString := (letterStart + (nr // letterRange - 1)) asString.
            nrString := nrString copyWith:(letterStart + (nr \\ letterRange))
        ] ifFalse:[
            nrString := (letterStart + (nr \\ letterRange)) asString
        ].
        nr := nr + 1.
    ].

    nrString := nrString , '.  '.

    xL := x - (currentFont widthOf:nrString).

    element origin:xL @ y.
    element type:#'li_ol'.
    element nr:nrString.

    listElement nextNumber:(nr + 1).
    ^ self.

    "Modified: 18.6.1996 / 22:39:57 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

li_ol
    |xL yT nrString|

    self conditionalBreak.
    previousIsEmpty := false.

    formatting ifTrue:[
        nrString := element nr.
        xL := x - (currentFont widthOf:nrString).
        element origin:xL @ y.
        ^ self
    ].

    y >= (displayTop-fontHeight) ifTrue:[
        y > (displayBottom+fontHeight) ifFalse:[
            xL := element origin x.
            xL > displayRight ifFalse:[
                needFontChange ifTrue:[
                    destination font:currentFont.
                    needFontChange := false.
                ].
                needColorChange ifTrue:[
                    destination paint:currentColor.
                    needColorChange := false.
                ].

                "/ in <ol> ... </ol>
                "/ draw the items number

                nrString := element nr.

                destination displayString:nrString x:xL y:y.
            ]
        ]
    ].

    "Modified: 22.5.1996 / 00:09:37 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

li_ul
    " in <ul> ... </ul> - draw a bullet"

    |xL yT org lvl clr img marker markerSize|

    self conditionalBreak.
    previousIsEmpty := false.

    marker := element markerType.

    (marker = 'disc' 
    or:[marker = 'arrow']) ifTrue:[
        markerSize := 15@10
    ] ifFalse:[
        (marker = 'square') ifTrue:[ 
            markerSize := 8@8
        ] ifFalse:[
            markerSize := 7@7
        ]
    ].

    destination isView ifFalse:[
        markerSize := markerSize * 0.7
    ].

    formatting ifTrue:[
        (marker = 'disc' 
        or:[marker = 'arrow']) ifTrue:[
            xL := x - (markerSize x + 1) - 4
        ] ifFalse:[
            xL := x - (markerSize x + 2) - 4.
        ].
        yT := y - (fontAscent//2) "+ 1" - (markerSize y // 2).

        element nr:ulLevel.
        element origin:(xL @ yT).
        ^ self
    ].

    org := element origin.
    yT := org y.

    yT >= (displayTop-8) ifTrue:[
        yT <= (displayBottom+8) ifTrue:[
            xL := org x.
            xL > displayRight ifFalse:[

                needColorChange ifTrue:[
                    destination paint:currentColor.
                    needColorChange := false.
                ].

                marker isNil ifTrue:[
                    lvl := element nr.

                    (lvl == 2) ifTrue:[marker := 'square']
                ].

                marker = 'disc' ifTrue:[
                    img := Depth1Image width:15 height:10 
                                    fromArray:#[
                                                2r00011111 2r11111110
                                                2r00100000 2r00000010
                                                2r01000000 2r00000010
                                                2r10000000 2r00000010
                                                2r10000000 2r00000010
                                                2r10000000 2r00000010
                                                2r10000000 2r00000010
                                                2r10000000 2r00000010
                                                2r10000000 2r00000010
                                                2r11111111 2r11111110
                                               ].

                    destination displayForm:img x:xL y:yT
                ] ifFalse:[
                    marker = 'square' ifTrue:[
                        destination displayRectangleX:xL
                                                    y:yT
                                                width:markerSize x
                                               height:markerSize y
                    ] ifFalse:[
                        marker = 'arrow' ifTrue:[
                            img := Depth1Image width:15 height:10 
                                            fromArray:#[
                                                        2r00000000 2r00000000
                                                        2r00000000 2r00100000
                                                        2r00000000 2r00110000
                                                        2r00000000 2r00111000
                                                        2r01111111 2r11111100
                                                        2r01111111 2r11111100
                                                        2r00000000 2r00111000
                                                        2r00000000 2r00110000
                                                        2r00000000 2r00100000
                                                        2r00000000 2r00000000
                                                       ].

                            destination displayForm:img x:xL y:yT
                        ] ifFalse:[
                            destination
                                fillArcX:xL y:yT 
                                width:markerSize x
                                height:markerSize y 
                                from:0
                                angle:360
                        ]
                    ]
                ].
            ]
        ].
    ].

    "Modified: 18.6.1996 / 22:39:27 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

menu
    self ul.
    element markerType isNil ifTrue:[
        element markerType:'arrow'.
    ]

    "Modified: 18.6.1996 / 22:44:13 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

menuEnd
    self ulEnd

    "Created: 22.6.1996 / 16:48:59 / cg"
!

ol
    |typeString type nr|

    self conditionalBreak.

    leftIndent := leftIndent + OLindent.
    x := x + OLindent.  lastTextX := nil.

    inOL == 0 ifTrue:[
        previousIsEmpty ifFalse:[
            self break
        ]
    ].
    inOL := inOL + 1.

    formatting ifTrue:[
        typeString := element typeString.
        typeString notNil ifTrue:[
            typeString = 'A' ifTrue:[
                type := #uppercaseLetters
            ] ifFalse:[
                typeString = 'a' ifTrue:[
                    type := #lowercaseLetters
                ] ifFalse:[
                    typeString = 'I' ifTrue:[
                        type := #uppercaseRoman
                    ] ifFalse:[
                        typeString = 'i' ifTrue:[
                            type := #lowercaseRoman
                        ] ifFalse:[
                            type := nil.
                        ]
                    ]
                ]
            ]
        ].

        nr := element parameterFor:'START'.
        nr isNil ifTrue:[
            nr := 1
        ] ifFalse:[
            nr := Integer readFrom:nr onError:nr.
            type == #uppercaseLetters ifTrue:[
                nr isNumber ifFalse:[
                    nr := nr first asciiValue - $A
                ]
            ].
            type == #lowercaseLetters ifTrue:[
                nr isNumber ifFalse:[
                    nr := nr first asciiValue - $a
                ]
            ].
        ].
        nr isNumber ifFalse:[
            nr := 1
        ].

        element nextNumber:nr.
        element numberType:type.
        liStack add:element.
    ]

    "Modified: 18.6.1996 / 22:19:10 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

olEnd
    self conditionalBreak.

    inOL := inOL - 1.
    inOL < 0 ifTrue:[
        'HTML: </ol> does not match any <ol>' errorPrintCR.
        inOL := 0.
    ] ifFalse:[
        leftIndent := leftIndent - OLindent.
        x := x - OLindent.  lastTextX := nil.

        formatting ifTrue:[
            liStack removeLast
        ]
    ].

    inOL == 0 ifTrue:[
        self conditionalEmpty.
    ]

    "Modified: 21.5.1996 / 12:30:25 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

ul
    |type|

    self conditionalBreak.
    leftIndent := leftIndent + ULindent.
    x := x + ULindent.  lastTextX := nil.

    ulLevel == 0 ifTrue:[
        previousIsEmpty ifFalse:[
            self break
        ]
    ].
    ulLevel := ulLevel + 1.

    formatting ifTrue:[
        scanning ifTrue:[
            element markerType:(element parameterFor:'TYPE').
        ].

        liStack add:element.
    ]

    "Modified: 18.6.1996 / 22:19:06 / cg"
    "Created: 22.6.1996 / 16:48:59 / cg"
!

ulEnd
    self conditionalBreak.

    ulLevel := ulLevel - 1.
    ulLevel < 0 ifTrue:[
        'HTML: </ul> does not match any <ul>' errorPrintCR.
        ulLevel := 0.
    ] ifFalse:[
        leftIndent := leftIndent - ULindent.
        x := x - ULindent.  lastTextX := nil.

        formatting ifTrue:[
            liStack removeLast
        ]
    ].

    ulLevel == 0 ifTrue:[
        self conditionalEmpty.
    ].

    "Modified: 21.5.1996 / 12:30:33 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
! !

!HTMLDocumentPainter methodsFor:'elements - special'!

a
    |urlString actionString clr|

    anchorElement notNil ifTrue:[
        'HTML: <a> within anchor' infoPrintNL.
    ].

    anchorElement := element.

    formatting ifTrue:[
        destination isView ifTrue:[
            boundsCollector := OrderedCollection new.
        ].

        scanning ifTrue:[
            anchorElement anchorText:nil.
        ].

        scanning ifTrue:[
            element isExample ifTrue:[
                clr := exampleFGColor.
                element color:clr.
            ]
        ]
    ] ifFalse:[
        clr := element color
    ].

    clr isNil ifTrue:[
        clr := textFGColor.

        element isExample ifTrue:[
            clr := exampleFGColor.
        ] ifFalse:[
            urlString := element hrefString.
            actionString := element actionString.

            urlString notNil ifTrue:[
                (imageAndStyleResolver visitTest:urlString action:actionString) ifTrue:[
                    clr := visitedAnchorFGColor.
                ] ifFalse:[
                    clr := anchorFGColor.
                ]
            ]
        ].
        element color:clr.
    ].

    currentColor ~~ clr ifTrue:[
        currentColor := clr.
        needColorChange := true.    
    ]

    "Created: 22.6.1996 / 16:49:00 / cg"
    "Modified: 5.9.1996 / 23:02:53 / cg"
!

aEnd
    formatting ifTrue:[
        currentColor := textFGColor.

        anchorElement isNil ifTrue:[
            'HTML: </a> but not within an anchor' errorPrintNL.
        ] ifFalse:[
            destination isView ifTrue:[
                boundsCollector notNil ifTrue:[
                    boundsCollector isEmpty ifTrue:[
                        boundsCollector := Array with:(Rectangle 
                                                        left:x top:y-fontAscent right:x bottom:y-fontAscent)
                    ].
                    anchorElement bounds:boundsCollector.
                ].
                anchors add:anchorElement.
            ]
        ].
        boundsCollector := nil
    ] ifFalse:[
        currentColor ~~ textFGColor ifTrue:[
            needColorChange := true.    
            currentColor := textFGColor.
        ].
    ].

    anchorElement := nil

    "Created: 22.6.1996 / 16:49:00 / cg"
    "Modified: 5.9.1996 / 22:57:29 / cg"
!

addText:txtIn fromElement:element
    |text wEnd w x0 quick lines l t nLines nr line
     limitTop limitBot fontWidth yt startsWithSep endsWithSep
     wordBuffer hadSpace|

    text := txtIn.
    hadSpace := needSpace.
    needSpace := false.
    text isNil ifTrue:[
        needSpace := true.
        ^ self
    ].

    headerDefinition notNil ifTrue:[
        text := self contentsAddHeader:text.
        element text:text
    ].

    collectingText ~~ 0 ifTrue:[
        scanning ifTrue:[
           collectedText size == 0 ifTrue:[
                text first == Character cr ifTrue:[
                    text := text copyFrom:2
                ].
                collectedText isNil ifTrue:[
                    collectedText := ''.
                ]
           ].
           collectedText := collectedText , text.
        ].
       ^ self
    ].

    formatting ifTrue:[
        scanning ifTrue:[
            anchorElement notNil ifTrue:[
                t := anchorElement anchorText.
                t isNil ifTrue:[
                    t := text.
                ] ifFalse:[
                    t := t , text
                ].
                anchorElement anchorText:t.
            ]
        ]
    ] ifFalse:[
        limitTop := displayTop-fontHeight.
        limitBot := displayBottom+fontHeight.
    ].

    currentFont == codeFont ifTrue:[
        fontWidth := fixFontWidth.
    ].

    inPre ~~ 0 ifTrue:[
        "/ preformatted text ...

        previousIsEmpty := false.

        yText notNil ifTrue:[
            y := yText.
            yText := nil.
        ].

        formatting ifTrue:[
            text isString ifTrue:[
                (text includes:(Character cr)) ifTrue:[
                    text := text asCollectionOfLines.
                ] ifFalse:[
                    text := text withTabsExpanded.
                ].
                element notNil ifTrue:[
                    element text:text.
                ]
            ].
        ].

        text isString ifFalse:[
            "/ multiple lines

            x0 := x.

            lines := text.

            nLines := lines size.
            nr := 1.
            [nr <= nLines] whileTrue:[
                line := lines at:nr.
                l := line withTabsExpanded.

                (l includes:(Character value:160)) ifTrue:[
                    l := l copy replaceAll:(Character value:160) with:Character space.
                ].

                fontWidth notNil ifTrue:[
                    w := l size * fontWidth
                ] ifFalse:[
                    w := currentFont widthOf:l.
                ].
                wEnd := x + w.

                formatting ifTrue:[
                    x0 := x0 min:x.
                    boundsCollector notNil ifTrue:[
                        boundsCollector add:(Rectangle left:x top:y-fontAscent 
                                                      right:wEnd bottom:y-fontAscent+fontHeight).
                    ].

                ] ifFalse:[
                    self privateDrawString:(l , ' ') atX:x y:y to:wEnd.
                ].
                x := lastTextX := wEnd.
                formatting ifTrue:[
                    x > maxWidth ifTrue:[maxWidth := x].
                ].

                nr ~~ nLines ifTrue:[self break].
                nr := nr + 1.
            ].

        ] ifTrue:[
            l := text , ' '.

            (l includes:(Character value:160)) ifTrue:[
                l replaceAll:(Character value:160) with:Character space.
            ].

            fontWidth notNil ifTrue:[
                w := l size * fontWidth
            ] ifFalse:[
                w := currentFont widthOf:l.
            ].    
            wEnd := x + w.

            formatting ifTrue:[
                boundsCollector notNil ifTrue:[
                    boundsCollector add:(Rectangle left:x top:y-fontAscent right:wEnd bottom:y-fontAscent+fontHeight).
                ].
            ] ifFalse:[
                self privateDrawString:l atX:x y:y to:wEnd.
            ].

            x := lastTextX := wEnd.
            formatting ifTrue:[
                x > maxWidth ifTrue:[maxWidth := x].
            ].
        ].
        ^ self
    ].

    "/ to be formatted ...

    text isString ifTrue:[
        text size > 0 ifTrue:[
            startsWithSep := text first isSeparator.
            text size > 1 ifTrue:[
                endsWithSep := text last isSeparator
            ] ifFalse:[
                endsWithSep := false
            ]
        ] ifFalse:[
            startsWithSep := endsWithSep := false
        ].
    ].

    scanning ifTrue:[
        text := text withoutSeparators.
        text isBlank ifTrue:[
            element notNil ifTrue:[
                element text:nil.
                needSpace := true
            ].
            ^ self
        ].
        text replaceAll:(Character cr) by:(Character space).
        startsWithSep ifTrue:[
            text := ' ' , text
        ].
        endsWithSep ifTrue:[
            text := text , ' '
        ].
        element notNil ifTrue:[
            element text:text.
        ]
    ].

    previousIsEmpty := false.

    yText notNil ifTrue:[
        y := yText.
        yText := nil.
    ].

    self atLeft ifTrue:[
        startsWithSep ifTrue:[
            text := text copyFrom:2
        ]
    ] ifFalse:[
        hadSpace == true ifTrue:[
            text := ' ' , text
        ]
    ].

    text isString ifTrue:[
        "/ a short string ?

        (text includes:(Character value:160)) ifTrue:[
            text := text copy replaceAll:(Character value:160) with:Character space.
        ].

        fontWidth notNil ifTrue:[
            w := text size * fontWidth
        ] ifFalse:[
            w := currentFont widthOf:text.
        ].
        wEnd := x + w.

        (wEnd <= (docWidth-rightIndent) 
        or:[noBreak ~~ 0]) ifTrue:[
            "/ all fits or forced-noBreak - dont break

            formatting ifTrue:[
                boundsCollector notNil ifTrue:[
                    boundsCollector add:(Rectangle 
                                            left:x top:y-fontAscent 
                                            right:wEnd bottom:y-fontAscent+fontHeight).
                ].
            ] ifFalse:[
                self privateDrawString:text atX:x y:y to:wEnd.
            ].

            x := lastTextX := wEnd.
            formatting ifTrue:[
                x > maxWidth ifTrue:[maxWidth := x].
            ].
            ^ self
        ].

        "/ break it up - but only once
        text := text asCollectionOfWords.
    ]. 

    "/ must break somewhere

    (self atLeft not and:[startsWithSep]) ifTrue:[
        wordBuffer := ' '.
    ] ifFalse:[
        wordBuffer := ''.
    ].

    x0 := x.

    text do:[:word |
        (word includes:(Character value:160)) ifTrue:[
            word replaceAll:(Character value:160) with:Character space.
        ].

        fontWidth notNil ifTrue:[
            w := word size * fontWidth
        ] ifFalse:[
            w := currentFont widthOf:word.
        ].
        wEnd := x + w.

        wEnd > (docWidth-rightIndent) ifTrue:[
            wordBuffer size > 0 ifTrue:[
                formatting ifTrue:[
                    boundsCollector notNil ifTrue:[
                        boundsCollector add:(Rectangle 
                                                left:x0 top:y-fontAscent 
                                                right:x bottom:y-fontAscent+fontHeight).
                    ].
                ] ifFalse:[
                    self privateDrawString:wordBuffer atX:x0 y:y to:x.
                ].
                wordBuffer := ''.
                lastTextX :=  x.
            ].

            self break.
            x0 := x.
            wEnd := x + w.
        ].

        formatting ifTrue:[
            x0 := x0 min:x.
        ].
        wordBuffer := wordBuffer , word , ' '.
        x := wEnd + wSpace.
    ].

    wordBuffer size > 0 ifTrue:[
        endsWithSep ifFalse:[
            x := x - wSpace.
        ].
        formatting ifTrue:[
            boundsCollector notNil ifTrue:[
                boundsCollector add:(Rectangle 
                                        left:x0 top:y-fontAscent 
                                        right:x bottom:y-fontAscent+fontHeight).
            ].
        ] ifFalse:[
"/ '[' print. wordBuffer print. ']' printCR.
            endsWithSep ifFalse:[
                wordBuffer := wordBuffer copyWithoutLast:1.
            ].
"/ '{' print. wordBuffer print. '}' printCR.

            self privateDrawString:wordBuffer atX:x0 y:y to:x.
            lastTextX := x
        ]
    ].

    "Created: 19.7.1996 / 23:43:31 / cg"
    "Modified: 5.9.1996 / 23:25:05 / cg"
!

anyFormElement:element
    |widget|

"/    formatting ifTrue:[
"/        scanning ifTrue:[
"/            widget := self createWidgetFor:element inForm:currentForm.
"/            widget notNil ifTrue:[
"/                element 
"/                    bounds:((x @ (y-(currentForm maxHeight+currentForm maxHeight-widget height))) extent:widget extent).
"/                x := x + widget width + wSpace.
"/            ].
"/            ^ self.
"/        ]
"/    ].

"/    formatting ifTrue:[
        widget := element view.
        widget notNil ifTrue:[
            formatting ifTrue:[
                element bounds:(x@(y-fontAscent) extent:(widget extent)).
            ].
            x := x + widget width + wSpace.
        ]
"/    ].

    "Modified: 26.5.1996 / 11:47:47 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

app
    self applet

    "Modified: 26.6.1996 / 09:15:17 / cg"
!

appEnd
    self appletEnd

    "Created: 22.6.1996 / 16:49:00 / cg"
    "Modified: 26.6.1996 / 09:15:30 / cg"
!

applet
    |v wWant hWant w h sp yI align|

    (v := element view) isNil ifTrue:[
        w := wWant := element numericParameterFor:'width='.
        h := hWant := element numericParameterFor:'height='.

        wWant isNil ifTrue:[^ self].
        hWant isNil ifTrue:[^ self].
    ] ifFalse:[
        w := v width.
        h := v height.
    ].

    previousIsEmpty := false.
    self conditionalBreak.
    sp := 0.

    y := y - fontAscent.

    h > fontHeight ifTrue:[
        yNextLine := y + h + (sp*2) + fontAscent.
    ].

    formatting ifTrue:[
        h < fontHeight ifTrue:[
            yI := y+sp+(fontHeight-h//2).
        ] ifFalse:[
            yI := y+sp.
        ].
        element bounds:(x@y extent:(v extent)).
    ].

    align := element align.

    align = 'top' ifTrue:[
    ] ifFalse:[
        align = 'bottom' ifTrue:[
            yText := y + h + fontAscent.
        ] ifFalse:[
            h > fontHeight ifTrue:[
                yText := y + (h // 2) + fontAscent.
            ] ifFalse:[
                yText := y + fontAscent
            ]
        ]
    ].

    boundsCollector notNil ifTrue:[
        boundsCollector add:(Rectangle left:x top:y width:w height:h).
    ].

    x := x + w + wSpace + (sp*2).

    y := y + fontAscent.

    "Modified: 24.5.1996 / 14:19:45 / cg"
    "Created: 26.6.1996 / 09:14:52 / cg"
!

appletEnd

    "Created: 26.6.1996 / 09:15:23 / cg"
!

area
    currentMap notNil ifTrue:[
        self halt.
    ]

    "Modified: 12.6.1996 / 20:10:34 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

img
    |lw i align w h yI sp oldPaint oldLW border isBadImage
     hSpace vSpace overAllH overAllW explicitBorder
     alt noBrokenImage yDelta|

    destination isView ifFalse:[
        anchorElement notNil ifTrue:[
            ((anchorElement hasParameterFor:'noprint')
            or:[(anchorElement parameterFor:'print') = 'no']) ifTrue:[
                ^ self.
            ]
        ].
        
        ((element hasParameterFor:'noprint')
        or:[(element parameterFor:'print') = 'no']) ifTrue:[
            ^ self.
        ].
    ].

    previousIsEmpty := false.

    scanning ifTrue:[
        isBadImage := false.

        i := imageAndStyleResolver imageFor:element urlString now:(formatting not).

        i isNil ifTrue:[
            isBadImage := true.
            i := imageAndStyleResolver imageFor:'brokenImage.xbm' now:true.
            i isNil ifTrue:[
                i := Image fromFile:'brokenImage.xbm'.
                i isNil ifTrue:[
                    noBrokenImage := true
                ]
            ]    
        ].
        i notNil ifTrue:[
            element image:i.
        ].

    ] ifFalse:[
        i := element image
    ].

    i isNil ifTrue:[
        "/ look for alternative
        alt := element parameterFor:'alt'.
        (alt isNil and:[noBrokenImage == true]) ifTrue:[
            alt := '[????]'
        ].
        alt notNil ifTrue:[
            self addText:alt fromElement:nil.
            ^ self
        ].
    ] ifFalse:[
        yDelta := fontAscent.
        (x + i width) > (docWidth-rightIndent) ifTrue:[
            self conditionalBreak.
            yDelta := 0.
        ].

        y := y - yDelta.

        lw := 2.
        border := element border.
        border notNil ifTrue:[
            explicitBorder := (element hasParameterFor:'BORDER') and:[border ~~ 0].
            lw := border max:0.
        ].

        w := i width.
        h := i height.

        (((lw ~~ 0) and:[self currentElementHasHREF])
        or:[explicitBorder == true]) ifTrue:[
            sp := lw.
            formatting ifFalse:[
                ( (y+h+sp+sp) >= displayTop
                and:[y-sp <= displayBottom
                and:[(x+w+sp+sp) >= displayLeft
                and:[x-sp <= displayRight]]]) ifTrue:[

                    needColorChange ifTrue:[
                        destination paint:currentColor.
                        needColorChange := false.
                    ].
                    oldLW := destination lineWidth.
                    destination lineWidth:sp.
                    destination displayRectangleX:x y:y width:w+sp+sp height:h+sp+sp.
                    destination lineWidth:oldLW.
                ]
            ]
        ] ifFalse:[
            sp := 0
        ].

        hSpace := element numericParameterFor:'HSPACE'.
        hSpace isNil ifTrue:[hSpace := 0].
        vSpace := element numericParameterFor:'VSPACE'.
        vSpace isNil ifTrue:[vSpace := 0].

        overAllH := vSpace+h+vSpace.
        overAllW := hSpace+w+hSpace.

        overAllH > fontHeight ifTrue:[
            yNextLine := y + overAllH + (sp*2) + fontAscent.
        ].

        destination isView ifFalse:[
            "/ synchronous display of images

            formatting ifFalse:[
                overAllH < fontHeight ifTrue:[
                    yI := y+sp+(fontHeight-overAllH//2).
                ] ifFalse:[
                    yI := y+sp.
                ].
                i := i on:destination device.
                destination displayForm:i x:x+sp+hSpace y:yI+vSpace.
            ]
        ] ifTrue:[
            "/ asynchronous display of images

            imagesToLoad isNil ifTrue:[
                imagesToLoad := SharedQueue new
            ].
            imagesToDisplay isNil ifTrue:[
                imagesToDisplay := SharedQueue new
            ].
            imageDisplayProcess isNil ifTrue:[
                self startImageDisplayProcess
            ].

            formatting ifFalse:[
                overAllH < fontHeight ifTrue:[
                    yI := y+sp+(fontHeight-overAllH//2).
                ] ifFalse:[
                    yI := y+sp.
                ].
                ((yI+overAllH) >= displayTop 
                and:[yI <= displayBottom
                and:[(x+sp) <= displayRight
                and:[(x+sp+overAllW) > displayLeft]]]) ifTrue:[
                    i device == destination device ifTrue:[
                        destination displayForm:i x:x+sp+hSpace y:yI+vSpace.
                    ] ifFalse:[
                        imagesToDisplay nextPut:(Array with:i
                                                       with:(x+sp+hSpace) @ (yI+vSpace)
                                                       with:currentColor
                                                       with:destination viewBackground).

                        destination paint:destination viewBackground.
                        destination fillRectangleX:x+sp y:yI
                                             width:overAllW height:overAllH.

                        needColorChange := true
                    ]
                ] ifFalse:[
                    i device ~~ destination device ifTrue:[
                        imagesToLoad nextPut:i.
                    ]
                ]
            ] ifTrue:[
                i device ~~ destination device ifTrue:[
                    imagesToLoad nextPut:i.
                ]
            ]
        ].

        align := element align.

        align = 'top' ifTrue:[
        ] ifFalse:[
            align = 'bottom' ifTrue:[
                yText := y + overAllH + fontAscent.
            ] ifFalse:[
                h > fontHeight ifTrue:[
                    yText := y + (overAllH // 2) + fontAscent.
                ] ifFalse:[
                    yText := y + fontAscent
                ]
            ]
        ].

        boundsCollector notNil ifTrue:[
            boundsCollector add:(Rectangle left:x top:y width:overAllW height:overAllH).
        ].
        
        x := x + overAllW + wSpace + (sp*2).  lastTextX := nil.
        x > maxWidth ifTrue:[
            maxWidth := x
        ].

        y := y + yDelta.
    ].

    "Created: 17.5.1996 / 16:44:19 / cg"
    "Modified: 5.9.1996 / 20:59:17 / cg"
!

map
    |nm|

    scanning ifTrue:[
        nm := element parameterFor:'NAME'.
        nm isNil ifTrue:[
            'HTML: no name given to map' infoPrintCR
        ] ifFalse:[
            maps isNil ifTrue:[
                maps := Dictionary new.
            ].
            maps at:nm put:(currentMap :=IdentityDictionary new).
        ]
    ]

    "Modified: 12.6.1996 / 20:10:08 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

mapEnd
    currentMap := nil.

    "Modified: 12.6.1996 / 20:10:18 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

privateDrawString:aString atX:xS y:yS to:xE
        |yt halfAscent limitTop limitBot|

        limitTop := displayTop-fontHeight.
        limitBot := displayBottom+fontHeight.

        xE < displayLeft ifTrue:[^ self].
        xS > displayRight ifTrue:[^ self].
        yS >= limitTop ifFalse:[^ self].
        yS <= limitBot ifFalse:[^ self].

        needColorChange ifTrue:[
            destination paint:currentColor.
            needColorChange := false.
        ].
        needFontChange ifTrue:[
            destination font:currentFont.
            needFontChange := false.
        ].

        inSup > 0 ifTrue:[
            yt := yS-SUPshift.
        ] ifFalse:[
            yt := yS.
        ].

        destination isView ifTrue:[
            destination displayString:aString x:xS y:yt.

            underline > 0 ifTrue:[
                destination displayLineFromX:xS y:(yS+1)
                                         toX:xE y:(yS+1).
            ].
            strikeout > 0 ifTrue:[
                halfAscent := (currentFont ascent // 2) - 1.
                destination displayLineFromX:xS y:(yS-halfAscent)
                                         toX:xE y:(yS-halfAscent).
            ].
        ] ifFalse:[
            destination underline:(underline > 0) strikeout:(strikeout > 0).
        
            lastTextX ~~ xS ifTrue:[
                destination displayString:aString x:xS y:yS.
            ] ifFalse:[
                destination displayStringAtLastPosition:aString.
            ].
            destination underline:false strikeout:false.
        ].

    "Modified: 5.9.1996 / 23:15:06 / cg"
!

specialMarkup
    self addText:element text fromElement:element

    "Modified: 19.7.1996 / 23:43:55 / cg"
! !

!HTMLDocumentPainter methodsFor:'elements - structure'!

br
    previousIsEmpty ifFalse:[
        self break.
    ]

    "Modified: 17.5.1996 / 18:40:47 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

h1
    self header:1 font:h1Font space:5
!

h1End
    self headerEnd

    "Modified: 17.5.1996 / 16:41:35 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

h2
    self header:2 font:h2Font space:4
!

h2End
    self headerEnd

    "Modified: 17.5.1996 / 16:41:41 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

h3
    self header:3 font:h3Font space:3
!

h3End
    self headerEnd

    "Modified: 17.5.1996 / 16:41:54 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

h4
    self header:4 font:h4Font space:2
!

h4End
    self headerEnd

    "Created: 22.6.1996 / 16:49:00 / cg"
!

h5
    self header:5 font:h5Font space:2
!

h5End
    self headerEnd

    "Created: 22.6.1996 / 16:49:00 / cg"
!

h6
    self header:6 font:h6Font space:2
!

h6End
    self headerEnd

    "Created: 22.6.1996 / 16:49:00 / cg"
!

hr
    |yL w sz right|

"/    previousIsEmpty ifFalse:[
"/        self empty
"/    ].
    self conditionalBreak.

    w := element numericParameterFor:'WIDTH' default:nil.
    sz := element numericParameterFor:'SIZE' default:2.

    formatting ifFalse:[
        yL := y - fontAscent + (fontAvgHeight//2) + (sz//2).
        yL >= displayTop ifTrue:[
            yL <= (displayBottom+sz) ifTrue:[
                needColorChange ifTrue:[
                    destination paint:currentColor.
                    needColorChange := false.
                ].
                destination lineWidth:sz.
                w isNil ifTrue:[
                    right := docWidth - rightIndent
                ] ifFalse:[
                    w isReal ifTrue:[
                        right := leftIndent + indentOffset + (docWidth - rightIndent * w // 100)
                    ] ifFalse:[
                        right := leftIndent + indentOffset+ w - 1
                    ]    
                ].

                destination 
                    displayLineFromX:leftIndent+indentOffset 
                                   y:yL 
                                 toX:right 
                                   y:yL.
                destination lineWidth:0.

                (element hasParameterFor:'NOSHADE') ifFalse:[
                    destination is3D ifTrue:[
                        destination paint:Color white.
                        needColorChange := true.
                        destination 
                            displayLineFromX:leftIndent+indentOffset 
                                           y:yL-1 
                                         toX:right 
                                           y:yL-1.
                    ]
                ].
                destination lineWidth:0.
            ]
        ]
    ].

    self empty.
    y := y + sz.
    previousIsEmpty := false.

"/    self break.

    "Created: 22.6.1996 / 16:49:00 / cg"
    "Modified: 10.7.1996 / 16:16:37 / cg"
!

nobr
    noBreak := noBreak + 1.

    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

nobrEnd
    noBreak := noBreak - 1.

    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

p
    |in s|

    formatting ifFalse:[
        destination isView ifFalse:[
            (element hasParameterFor:'newpage') ifTrue:[
                self break.
                self pageBreak.
                previousIsEmpty := true.
            ].
        ].
    ].

    in := element parameterFor:'indent'.
    in notNil ifTrue:[
        s := in readStream.
        s peek == $+ ifTrue:[
            s next.
            indentOffset := indentOffset + (Number readFrom:s onError:0)
        ] ifFalse:[
            s peek == $- ifTrue:[
                s next.
                indentOffset := indentOffset - (Number readFrom:s onError:0).
            ] ifFalse:[
                indentOffset := (Number readFrom:s onError:indentOffset)
            ]
        ].
        indentOffset < 0 ifTrue:[indentOffset := 0].
    ] ifFalse:[
        indentOffset := 0
    ].
    self conditionalEmpty.

"/    self conditionalBreak.
"/    previousIsEmpty ifFalse:[
"/        self break.
"/    ].
    previousIsEmpty := true.

    "Modified: 17.5.1996 / 18:44:11 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

pre
    self conditionalEmpty.
"/    self conditionalBreak.
"/    previousIsEmpty ifFalse:[
"/        self break
"/    ].
    self setFont:codeFont.
    inPre := inPre + 1.


    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

preEnd
"/    |wasEmpty|

    self empty.

"/    wasEmpty := previousIsEmpty.
"/    self conditionalBreak.
"/    wasEmpty ifFalse:[
"/        self break
"/    ].
    self setFont:normalFont.
    inPre := inPre - 1.

    inPre < 0 ifTrue:[
        'HTML: </pre> without matching <pre> - ignored' infoPrintCR.
        inPre := 0.
    ].

    "Modified: 17.5.1996 / 18:51:01 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

tab
    |id tab|

    formatting ifTrue:[
        id := element parameterFor:'ID'.
        id notNil ifTrue:[
            tabulators isNil ifTrue:[
                tabulators := Dictionary new
            ].
            tabulators at:id put:x.
            ^ self
        ].
    ].

    id := element parameterFor:'TO'.
    id notNil ifTrue:[
        tabulators notNil ifTrue:[
            tab := tabulators at:id ifAbsent:nil
        ].
        tab notNil ifTrue:[
            x := tab.  lastTextX := nil.
        ]
    ].

    "Modified: 18.6.1996 / 21:48:30 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

wbr
    previousIsEmpty ifFalse:[
        self break.
    ]

    "Modified: 17.5.1996 / 18:40:47 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
! !

!HTMLDocumentPainter methodsFor:'elements - style'!

acronym
    self cite

    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

acronymEnd
    self citeEnd

    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

address
    self setFont:boldItalicNormalFont.

    "Modified: 18.6.1996 / 18:15:06 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

addressEnd
    inPre ~~ 0 ifTrue:[
        self setFont:codeFont.
    ] ifFalse:[        
        self setFont:normalFont.
    ]

    "Modified: 18.5.1996 / 10:42:56 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

b
    currentFont == codeFont ifTrue:[
        self setFont:boldCodeFont.
    ] ifFalse:[
        self setFont:boldNormalFont.
    ]

    "Modified: 18.6.1996 / 18:43:50 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

bEnd
    inPre ~~ 0 ifTrue:[
        self setFont:codeFont.
    ] ifFalse:[        
        self setFont:normalFont.
    ]

    "Created: 22.6.1996 / 16:49:00 / cg"
!

cite
    self setFont:italicNormalFont.

    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

citeEnd
    inPre ~~ 0 ifTrue:[
        self setFont:codeFont.
    ] ifFalse:[        
        self setFont:normalFont.
    ]

    "Modified: 18.5.1996 / 10:42:56 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

code
    self setFont:codeFont.

    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

codeEnd
    inPre ~~ 0 ifTrue:[
        self setFont:codeFont.
    ] ifFalse:[        
        self setFont:normalFont.
    ]

    "Created: 22.6.1996 / 16:49:00 / cg"
!

dfn
    self cite.
    self u.

    "Created: 22.6.1996 / 16:49:00 / cg"
    "Modified: 19.7.1996 / 14:24:13 / cg"
!

dfnEnd
    self citeEnd.
    self uEnd.

    "Created: 22.6.1996 / 16:49:00 / cg"
    "Modified: 19.7.1996 / 14:24:21 / cg"
!

em
    currentFont == codeFont ifTrue:[
        self setFont:italicCodeFont.
    ] ifFalse:[
        self setFont:italicNormalFont.
    ]

    "Modified: 18.6.1996 / 18:43:27 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

emEnd
    (inPre ~~ 0 
    or:[currentFont == italicCodeFont]) ifTrue:[
        self setFont:codeFont.
    ] ifFalse:[        
        self setFont:normalFont.
    ]

    "Modified: 18.6.1996 / 18:45:03 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

font
    |clr|

    formatting ifFalse:[
        clr := element colorParameter.
        clr notNil ifTrue:[
            currentColor := clr.
            needColorChange := true.
        ].
    ]

    "Modified: 12.6.1996 / 18:12:38 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

fontEnd
    inPre ~~ 0 ifTrue:[
        self setFont:codeFont.
    ] ifFalse:[        
        self setFont:normalFont.
    ].
    currentColor := textFGColor.
    needColorChange := true.

    "Modified: 12.6.1996 / 17:20:54 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

i
    currentFont == boldNormalFont ifTrue:[
        self setFont:boldItalicNormalFont.
    ] ifFalse:[
        currentFont == codeFont ifTrue:[
            self setFont:italicCodeFont.
        ] ifFalse:[
            self setFont:italicNormalFont.
        ]
    ]

    "Modified: 18.6.1996 / 18:46:33 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

iEnd
    inPre ~~ 0 ifTrue:[
        self setFont:codeFont.
    ] ifFalse:[        
        self setFont:normalFont.
    ]

    "Created: 22.6.1996 / 16:49:00 / cg"
!

kbd
    self setFont:boldCodeFont.

    "Modified: 18.6.1996 / 18:15:59 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

kbdEnd
    inPre ~~ 0 ifTrue:[
        self setFont:codeFont.
    ] ifFalse:[        
        self setFont:normalFont.
    ]

    "Created: 22.6.1996 / 16:49:00 / cg"
!

s
    strikeout := strikeout + 1

    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

sEnd
    strikeout := (strikeout - 1) max:0

    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

samp
    self code

    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

sampEnd
    self codeEnd

    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

strong
    currentFont == codeFont ifTrue:[
        self setFont:boldCodeFont.
    ] ifFalse:[
        self setFont:boldNormalFont.
    ]

    "Modified: 18.6.1996 / 18:44:24 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

strongEnd
    (inPre ~~ 0 
    or:[currentFont == boldCodeFont]) ifTrue:[
        self setFont:codeFont.
    ] ifFalse:[        
        self setFont:normalFont.
    ]

    "Modified: 18.6.1996 / 18:44:43 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

sub
    self setFont:normalSmallFont.

    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

subEnd
    inPre ~~ 0 ifTrue:[
        self setFont:codeFont.
    ] ifFalse:[        
        self setFont:normalFont.
    ]

    "Created: 22.6.1996 / 16:49:00 / cg"
!

sup
    inSup := inSup + 1.
    self setFont:normalSmallFont.

    "Modified: 21.5.1996 / 10:28:12 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

supEnd
    inSup := (inSup - 1) max:0.
    inSup == 0 ifTrue:[
        inPre ~~ 0 ifTrue:[
            self setFont:codeFont.
        ] ifFalse:[        
            self setFont:normalFont.
        ]
    ]

    "Modified: 21.5.1996 / 10:28:40 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

tt
    self setFont:codeFont.

    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

ttEnd
    inPre ~~ 0 ifTrue:[
        self setFont:codeFont.
    ] ifFalse:[        
        self setFont:normalFont.
    ]

    "Created: 22.6.1996 / 16:49:00 / cg"
!

u
    underline := underline + 1

    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

uEnd
    underline := (underline - 1) max:0

    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:00 / cg"
!

var
    self setFont:italicNormalFont.

    "Modified: 17.5.1996 / 18:50:58 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
!

varEnd
    inPre ~~ 0 ifTrue:[
        self setFont:codeFont.
    ] ifFalse:[        
        self setFont:normalFont.
    ]

    "Modified: 18.5.1996 / 10:45:42 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
! !

!HTMLDocumentPainter methodsFor:'elements - tables'!

caption
    currentTable notNil ifTrue:[
        self finishPreviousTableRow.
    ]

    "Created: 22.6.1996 / 16:49:01 / cg"
!

drawTable
    |yTop yBot xRight rows yPrevRow wSpace clr|

    currentTable hasBorder ifFalse:[^ self].
    formatting ifTrue:[^ self].

    needColorChange ifTrue:[
        destination paint:currentColor.
        needColorChange := false.
    ].

    wSpace := currentTable spaceInset.

    yTop := currentTable top.
    yTop > displayBottom ifTrue:[^ self].

    yBot := yTop + currentTable height.
    yBot < displayTop ifTrue:[^ self].

    xRight := leftIndent + indentOffset + currentTable maxWidth + wSpace.

    clr := currentTable colorParameter:'BORDERCOLOR'.
    clr notNil ifTrue:[
        destination paint:clr.
        needColorChange := true
    ].

    yTop >= displayTop ifTrue:[
        yTop <= displayBottom ifTrue:[
            destination 
                displayLineFromX:leftIndent + indentOffset 
                               y:yTop 
                             toX:xRight 
                               y:yTop.
            ]
    ].

    (yTop >= displayTop or:[yBot >= displayTop]) ifTrue:[
        (yTop <= displayBottom or:[yBot <= displayBottom]) ifTrue:[
            (((leftIndent + indentOffset) >= displayLeft)
            and:[(leftIndent + indentOffset) <= displayRight]) ifTrue:[
                destination 
                    displayLineFromX:leftIndent + indentOffset 
                                   y:yTop 
                                 toX:leftIndent + indentOffset 
                                   y:yTop + currentTable height.
            ].

            ((xRight >= displayLeft)
            and:[xRight <= displayRight]) ifTrue:[
                destination 
                    displayLineFromX:xRight 
                                   y:yTop 
                                 toX:xRight 
                                   y:yTop + currentTable height.
            ]
        ]
    ].

    yBot >= displayTop ifTrue:[
        yBot <= displayBottom ifTrue:[
            destination 
                displayLineFromX:leftIndent + indentOffset 
                               y:yBot 
                             toX:xRight 
                               y:yBot.
        ]
    ].

    yPrevRow := yTop.
    (rows := currentTable rows) keysAndValuesDo:[:index :row |
        |cols yRow xCol|
        
        cols := row at:#columns.

        index ~~ rows size ifTrue:[
            yRow := (row at:#y).
            yRow >= displayTop ifTrue:[
                yRow <= displayBottom ifTrue:[
                    destination 
                        displayLineFromX:leftIndent + indentOffset 
                                       y:yRow 
                                     toX:xRight 
                                       y:yRow.
                ]
            ].
        ] ifFalse:[
            yRow := yBot
        ].

        (yRow >= displayTop or:[yPrevRow >= displayTop]) ifTrue:[
            (yRow <= displayBottom or:[yPrevRow <= displayBottom]) ifTrue:[
                cols keysAndValuesDo:[:colIndex :col |
                    colIndex ~~ 1 ifTrue:[
                        xCol := col at:#x.
                        xCol := xCol - wSpace.
                        ((xCol >= displayLeft)
                        and:[xCol <= displayRight]) ifTrue:[
                            destination 
                                displayLineFromX:xCol 
                                               y:yPrevRow 
                                             toX:xCol 
                                               y:yRow.
                        ]
                    ]
                ]
            ]
        ].
        yPrevRow := yRow.
   ].

    "Modified: 18.6.1996 / 22:52:37 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
!

drawTableRow:row
    "draw one row
    "
    |xLeft xRight yBot yTop clr|

    formatting ifTrue:[^ self].
    currentTable hasBorder ifFalse:[^ self].

    needColorChange ifTrue:[
        destination paint:currentColor.
        needColorChange := false.
    ].

    clr := currentTable colorParameter:'BORDERCOLOR'.
    clr notNil ifTrue:[
        destination paint:clr.
        needColorChange := true
    ].

    yBot   := row at:#y.
    xLeft  := leftIndent + indentOffset + wSpace.
    xRight := xLeft + currentTable maxWidth.

    currentRowIndex == 1 ifTrue:[
        yTop := currentTable top
    ] ifFalse:[
        yTop := (currentTable rows at:(currentRowIndex -1)) at:#y
    ].
    yBot < yTop ifTrue:[
        yTop := destination topMargin.
    ].
    xRight > displayRight ifTrue:[
        xRight := displayRight
    ] ifFalse:[
        destination displayLineFromX:xRight y:yTop toX:xRight y:yBot
    ].
    destination displayLineFromX:xLeft y:yBot toX:xRight y:yBot.

    currentRowIndex == 1 ifTrue:[
        destination displayLineFromX:xLeft y:yTop toX:xRight y:yTop.
    ].
    (row at:#columns) do:[:col| |xCol|
        (xCol := (col at:#x) - wSpace) <= displayRight ifTrue:[
            destination displayLineFromX:xCol y:yTop toX:xCol y:yBot
        ]
    ].
!

finishPreviousTableColumn
    |prevRow cols prevCol|

    currentRowIndex ~~ 0 ifTrue:[
        prevRow := currentTable rowAt:currentRowIndex.
        cols := (prevRow at:#columns).
        cols notEmpty ifTrue:[
            x := x + wSpace.  lastTextX := nil.

            formatting ifTrue:[
                prevCol := cols last.
                prevCol at:#width put:(x - (prevCol at:#xText)).
            ]
        ].
    ].

    "Created: 22.6.1996 / 16:49:01 / cg"
    "Modified: 3.7.1996 / 15:13:48 / cg"
!

finishPreviousTableRow
    |row|

    currentRowIndex ~~ 0 ifTrue:[
        self finishPreviousTableColumn.

        row := currentTable rowAt:currentRowIndex.
    ]

    "Modified: 13.6.1996 / 18:21:31 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
!

table
    |yTop|

    self conditionalBreak.

    scanning ifTrue:[
        currentTable notNil ifTrue:[
            currentTable := nil.
            'HTML: table within table - ignored' infoPrintCR.
        ]
    ].

    currentTable := element.
    currentRowIndex := currentColIndex := 0.

    noBreak := noBreak + 1.
    y := y + (fontHeight//3) + 1.

    formatting ifTrue:[
        currentTable top:y - fontAscent - (fontHeight//3).
        currentTable inset:fontHeight//3.
        currentTable spaceInset:wSpace.
    ] ifFalse:[
        destination isView ifTrue:[   "CLAUS"
            self drawTable
        ]
    ].

    "Modified: 18.6.1996 / 22:54:46 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
!

tableEnd
    |wMax wRow yTop yBot maxNumCols wMaxPerCol differentNumberOfCols
     xCol inset numColsInRow wThisCol|

    currentTable isNil ifTrue:[
        'HTML: table/ but not within table - ignored' infoPrintCR.
    ] ifFalse:[
        self finishPreviousTableRow.
        self conditionalBreak.

        wSpace := currentTable spaceInset.

        formatting ifTrue:[
            "/ search through table - gather max width

            maxNumCols := currentTable rows inject:0 into:[:maxSoFar :row | maxSoFar max:(row at:#columns) size].
            differentNumberOfCols := false.

            wMaxPerCol := Array new:maxNumCols withAll:0.

            inset := currentTable inset.

            currentTable rows do:[:row |
                |cols|

                cols := row at:#columns.
                cols size ~~ maxNumCols ifTrue:[differentNumberOfCols := true].

                cols keysAndValuesDo:[:colIndex :col |
                    |wMax wThis|

                    wMax := wMaxPerCol at:colIndex.
                    wThis := (col at:#width).
                    wThis := wThis + inset + inset.
                    wMaxPerCol at:colIndex put:(wMax max:wThis).
                ].
            ].

            wMax := wMaxPerCol inject:0 into:[:sum :w | sum + w + 1].
            currentTable maxWidth:wMax.

            "/ patchup col-x positions

            differentNumberOfCols ifTrue:[
                'HTML: different number of columns in table' infoPrintCR
            ].

            currentTable rows do:[:row |
                |cols el align|

                "/ rows alignment
                el := row at:#markup.
                align := el parameterFor:'ALIGN'.
                align isNil ifTrue:[
                    align := #center
                ] ifFalse:[
                    (align := align asLowercase) = 'left' ifTrue:[
                        align := #left
                    ] ifFalse:[
                        align = 'right' ifTrue:[
                            align := #right
                        ] ifFalse:[
                            align := #center
                        ]
                    ]
                ].

                cols := row at:#columns.
                numColsInRow := cols size.

                cols keysAndValuesDo:[:colIndex :col |
                    |x wCol wMaxCol colAlign|

                    "/ per-col alignment
                    el := col at:#markup.
                    colAlign := el parameterFor:'ALIGN'.
                    colAlign isNil ifTrue:[
                        colAlign := align
                    ] ifFalse:[
                        (colAlign := colAlign asLowercase) = 'left' ifTrue:[
                            colAlign := #left
                        ] ifFalse:[
                            colAlign = 'right' ifTrue:[
                                colAlign := #right
                            ] ifFalse:[    
                                colAlign = 'center' ifTrue:[
                                    colAlign := #center
                                ]
                            ]
                        ]
                    ].
                
                    colIndex == 1 ifTrue:[
                        xCol := (col at:#x)
                    ] ifFalse:[
                        col at:#x put:xCol
                    ].

                    wCol := col at:#width.             "/ the width req'd for this col
                    wMaxCol := wMaxPerCol at:colIndex. "/ the max width of this col (over all rows)
                    wThisCol := wMaxCol.

                    numColsInRow < maxNumCols ifTrue:[
                        "/ the last col in a row with less columns
                        colIndex == numColsInRow ifTrue:[
                            "/ extend it to the right
                        
                            colIndex+1 to:maxNumCols do:[:remainingColsIndex |
                                wThisCol := wThisCol + (wMaxPerCol at:remainingColsIndex) + wSpace.
                            ]
                        ]
                    ].

                    colAlign == #left ifTrue:[
                        col at:#xText put:xCol.
                    ] ifFalse:[
                        colAlign == #center ifTrue:[
                            col at:#xText put:(xCol + (wThisCol - wSpace - wSpace - wCol // 2))
                        ] ifFalse:[
                            col at:#xText put:(xCol + (wThisCol - wSpace - wSpace - wCol))
                        ]
                    ].

                    xCol := xCol + wThisCol + wSpace.
                    xCol > maxWidth ifTrue:[maxWidth := xCol].
                ]
            ]
        ].

        formatting ifTrue:[
            yBot := y - fontAscent + inset.
            currentTable height:yBot - (currentTable top).
        ] ifFalse:[
            destination isView ifTrue:[   "CLAUS"
                self drawTable
            ]
        ]
    ].
    currentTable := nil.
    noBreak := noBreak - 1.
    y := y + (fontHeight//3) + 1.

    "Created: 22.6.1996 / 16:49:01 / cg"
    "Modified: 3.7.1996 / 15:34:57 / cg"
!

td
    currentTable notNil ifTrue:[
        self setFont:normalFont.
    ].
    self th_td_common

    "Created: 22.6.1996 / 16:49:01 / cg"
    "Modified: 3.7.1996 / 14:50:44 / cg"
!

th
    currentTable notNil ifTrue:[
        self setFont:boldNormalFont.
    ].
    self th_td_common

    "Created: 22.6.1996 / 16:49:01 / cg"
    "Modified: 3.7.1996 / 14:50:23 / cg"
!

th_td_common
    |row col|

    currentTable notNil ifTrue:[
        self finishPreviousTableColumn.

        row := currentTable rowAt:currentRowIndex.

        currentColIndex := currentColIndex + 1.
        scanning ifTrue:[
            col := IdentityDictionary new.
            (row at:#columns) add:col.
            col at:#markup put:element.
        ] ifFalse:[
            col := (row at:#columns) at:currentColIndex.
        ].

        formatting ifTrue:[
            currentColIndex == 1 ifTrue:[
                "/ x already set
            ] ifFalse:[
                x := x + 1 + (currentTable spaceInset * 2).
            ].
            col at:#x put:x.
            col at:#xText put:x.
        ] ifFalse:[
            x := (col at:#xText) + currentTable inset.
        ].
         lastTextX := nil.
    ]

    "Created: 3.7.1996 / 14:50:33 / cg"
    "Modified: 3.7.1996 / 15:11:40 / cg"
!

tr
    |row yTop yBot|

    currentTable notNil ifTrue:[
        self finishPreviousTableRow.

        currentRowIndex := currentRowIndex + 1.

        scanning ifTrue:[
            row := IdentityDictionary new.
            row at:#columns put:OrderedCollection new.
            row at:#markup put:element.
            currentTable addRow:row.
        ] ifFalse:[
            row := currentTable rowAt:currentRowIndex
        ].

        currentColIndex := 0.
        self conditionalBreak.

        currentRowIndex ~~ 1 ifTrue:[
            y := y + (currentTable inset * 2).
        ].

        formatting ifTrue:[
            row at:#y put:y + fontHeight - fontAscent + currentTable inset.
            x := x + currentTable inset "/ same inset as top/bottom
        ] ifFalse:[
            destination isView ifTrue:[ "CLAUS"
                self drawTable
            ] ifFalse:[
                self drawTableRow:row
            ]
        ]
    ]

    "Modified: 18.6.1996 / 18:52:16 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
! !

!HTMLDocumentPainter methodsFor:'formatting'!

addSyncPoint
    syncPoints add:(self shallowCopy)

    "Created: 22.6.1996 / 16:49:01 / cg"
!

flushAnchorColors
    ^ self.

    anchors notNil ifTrue:[
        anchors do:[:a |
            a isExample ifFalse:[
                a color ~~ visitedAnchorFGColor ifTrue:[
                    a color:nil
                ]
            ]
        ]
    ].

    "Modified: 21.5.1996 / 23:40:05 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
!

format:aDocument for:aGC resolver:aResolver style:aStyle
    |fontSize|

    scanning := true.
    imageAndStyleResolver := aResolver.
    formattingStyle := aStyle.

    aDocument == document ifTrue:[
        ^ self.
        scanning := false
    ] ifFalse:[
        self destroyWidgets.
        anchors:= OrderedCollection new.
        document := aDocument.
        docWidth := nil.
        metaCommands := nil.
    ].

    maxWidth := maxHeight := 0.

    aGC title:''.
    aDocument isNil ifTrue:[
        ^ self
    ].

    destination := aGC.

    textFGColor := aStyle at:#textFGColor.
    anchorFGColor := aStyle at:#anchorFGColor.
    activeAnchorFGColor := aStyle at:#activeAnchorFGColor.
    activeAnchorBGColor := aStyle at:#activeAnchorBGColor.
    visitedAnchorFGColor := aStyle at:#visitedAnchorFGColor.
    exampleFGColor := aStyle at:#exampleFGColor.

    fontSize := 10.

    normalFont           := aStyle at:#normalFont.
    boldNormalFont       := aStyle at:#boldNormalFont.
    italicNormalFont     := aStyle at:#italicNormalFont.
    boldItalicNormalFont := aStyle at:#boldItalicNormalFont.

    codeFont             := aStyle at:#codeFont.
    boldCodeFont         := aStyle at:#boldCodeFont.
    italicCodeFont       := aStyle at:#italicCodeFont.
    boldItalicCodeFont   := aStyle at:#boldItalicCodeFont.

    normalSmallFont      := aStyle at:#normalSmallFont.

    h1Font               := aStyle at:#h1Font.
    h2Font               := aStyle at:#h2Font.
    h3Font               := aStyle at:#h3Font.
    h4Font               := aStyle at:#h4Font.
    h5Font               := aStyle at:#h5Font.
    h6Font               := aStyle at:#h6Font.

    self getFontsFor:aGC.

    self prescanForms.

    arrayOfHeaderIndex := self initialHeaderNumbers.
    listOfHeaders      := nil.

    self reformatDocument.
    arrayOfHeaderIndex := nil.

    scanning := false.

    self processMetaCommands

    "Created: 5.9.1996 / 21:20:14 / cg"
    "Modified: 7.9.1996 / 15:39:45 / cg"
!

process:aDocument
    |nextSyncY prevType quickDraw|

    quickDraw := true.

    document := aDocument.
    nextSyncY := 100.

    aDocument keysAndValuesDo:[:idx :e |
        |type|

        (prevType == #'/form') ifTrue:[
            self addSyncPoint.
        ].

        elementIndex := idx.
        element := e.
        type := e type.

        (type == #form) ifTrue:[
            self addSyncPoint.
        ] ifFalse:[
            (y >= nextSyncY) ifTrue:[
                self addSyncPoint.
                nextSyncY := nextSyncY + 300.
            ].
        ].

        type isNil ifTrue:[
            self specialMarkup
        ] ifFalse:[
            type := SelectorTable at:type ifAbsent:type.
            (type endsWith:$/) ifFalse:[
"/            self perform:type ifNotUnderstood:[].
                self perform:type
            ]
        ].
        prevType := type.

"/        quickDraw ifTrue:[
"/            formatting ifTrue:[
"/                y > destination height ifTrue:[
"/                    quickDraw := false.
"/                    self shallowCopy 
"/                            displayX:0 y:0 width:destination width height:destination height on:destination
"/                ].
"/            ].
"/        ].
    ]

    "Modified: 18.6.1996 / 21:13:11 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
!

reformatDocument
    |fontSize|

    imageDisplayProcess notNil ifTrue:[
        imageDisplayProcess terminate.
        imageDisplayProcess := imagesToDisplay := nil.
    ].

    destination width == docWidth ifTrue:[
        ^ self.
    ].
    docWidth := destination width.
    formatting := true.
    inHeader := false.

    syncPoints := OrderedCollection new:50.

    destination isView ifTrue:[
        topMargin     := 20.
        leftMargin    := 20.
        rightMargin   := 20.
    ] ifFalse:[
        leftMargin    := 0.
        topMargin     := destination topMargin.
        rightMargin   := destination rightMargin.
    ].

    leftIndent    := leftMargin.
    rightIndent   := rightMargin.
    indentOffset  := 0.
    pageNumber    := 1.

    collectingText := inPre := inBLOCKQUOTE := 0.
    ulLevel := inDL := inOL := 0.
    underline := strikeout := inSup := noBreak := 0.

    self setFont:normalFont.
    normalFontHeight := fontAvgHeight.

    lastTextX := nil.
    x := leftIndent.
    y := topMargin + fontAscent.

    wSpace := currentFont widthOf:' '.

    currentColor := textFGColor.

    maxWidth := 0.
    yNextLine := nil.
    previousIsEmpty := false.
    liStack := OrderedCollection new.

    anchorElement := hBegin := nil.
    currentMap := currentForm :=  currentTable := nil.

    self process:document.

    self conditionalBreak.
    maxHeight := y.

    "Created: 22.6.1996 / 16:49:01 / cg"
    "Modified: 5.9.1996 / 22:29:01 / cg"
!

release
    "/ sent from docView, to release stuff

    self terminateMetaCommands.

    imageDisplayProcess notNil ifTrue:[
        imageDisplayProcess terminate.
    ].
    imageDisplayProcess := imagesToDisplay := nil.

    "Modified: 17.6.1996 / 20:57:15 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
!

resyncFrom:syncPoint
    "/ fetch the state found there

    x := syncPoint xPosition.  lastTextX := nil.
    y := syncPoint yPosition.
    fontHeight := syncPoint currentFontHeight.
    fontAscent := syncPoint currentFontAscent.
    fontAvgHeight := syncPoint currentFontAvgHeight.

    leftIndent := syncPoint currentLeftIndent.
    indentOffset := syncPoint currentIndentOffset.
    rightIndent := syncPoint currentRightIndent.
    yNextLine := syncPoint yNextLine.
    yText := syncPoint yText.

    anchorElement := nil.
    previousIsEmpty := syncPoint previousIsEmpty.
    inPre := syncPoint inPre.
    inDL := syncPoint inDL.
    inOL := syncPoint inOL.
    inBLOCKQUOTE := syncPoint inBLOCKQUOTE.
    inSup := syncPoint inSup.
"/        inSub := syncPoint inSub.
    underline := syncPoint inUnderline.
    strikeout := syncPoint inStrikeout.
    ulLevel := syncPoint ulLevel.
    noBreak := syncPoint inNoBreak.

    currentColor := syncPoint currentColor.
    currentFont := syncPoint currentFont.
    currentForm := syncPoint currentForm.
    currentTable := syncPoint currentTable.
    currentRowIndex := syncPoint currentRowIndex.
    currentColIndex := syncPoint currentColIndex.
    needFontChange := needColorChange := true.

    hBegin := syncPoint hBegin.

    elementIndex := syncPoint elementIndex.

    "Modified: 13.6.1996 / 16:02:24 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
!

terminateMetaCommands
    "/ sent from docView, to release stuff

    subProcesses notNil ifTrue:[
        subProcesses do:[:aProcess |
            aProcess terminate
        ].
        subProcesses := nil.
    ].

    "Modified: 12.6.1996 / 19:47:32 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
! !

!HTMLDocumentPainter methodsFor:'helpers'!

atLeft
    ^ x == (leftIndent + indentOffset)

    "Created: 22.6.1996 / 16:49:01 / cg"
!

break
    yNextLine notNil ifTrue:[
        y := yNextLine
    ] ifFalse:[
        (currentForm notNil and:[destination isView]) ifTrue:[
            y := y + currentForm maxHeight + 3.
        ] ifFalse:[
            x = (leftIndent+indentOffset) ifTrue:[
                y := y + fontAvgHeight.
                previousIsEmpty := true.
            ] ifFalse:[
                y := y + fontHeight
            ]
        ]
    ].
    x := leftIndent+indentOffset.  lastTextX := nil.

    yNextLine := nil.
    yText := nil.

    (y > self pageBreakLimit and:[destination isView not]) ifTrue:[
         self pageBreak
    ].

!

conditionalBreak
    "break line if not already at the beginning"

    self atLeft ifFalse:[
        self break
    ].

    (y > self pageBreakLimit and:[destination isView not]) ifTrue:[
         self pageBreak
    ].

    "Created: 22.6.1996 / 16:49:01 / cg"
!

conditionalEmpty
    previousIsEmpty ifFalse:[
        self empty.
    ].

    "Created: 22.6.1996 / 16:49:01 / cg"
!

currentElementHasHREF
    anchorElement notNil ifTrue:[
        anchorElement hrefString notNil ifTrue:[        
            ^ true
        ]
    ].
    ^ false

    "Created: 22.6.1996 / 16:49:01 / cg"
!

empty
    self empty:normalFontHeight

    "Created: 22.6.1996 / 16:49:01 / cg"
!

empty:height
    height <= 0 ifTrue:[^ self].

    self atLeft ifFalse:[
        self break
    ].

    yNextLine notNil ifTrue:[
        y := yNextLine
    ].

    y := y + height.
    yText := nil.
    previousIsEmpty := true.
    lastTextX := nil.

    (y > self pageBreakLimit and:[destination isView not]) ifTrue:[
         self pageBreak
    ].

!

getFontsFor:aGC
    normalFont := normalFont on:aGC device.
    boldNormalFont := boldNormalFont on:aGC device.
    italicNormalFont := italicNormalFont on:aGC device.
    boldItalicNormalFont := boldItalicNormalFont on:aGC device.

    codeFont := codeFont on:aGC device.
    boldCodeFont := boldCodeFont on:aGC device.
    italicCodeFont := italicCodeFont on:aGC device.
    boldItalicCodeFont := boldItalicCodeFont on:aGC device.

    normalSmallFont := normalSmallFont on:aGC device.

    h1Font := h1Font on:aGC device.
    h2Font := h2Font on:aGC device.
    h3Font := h3Font on:aGC device.
    h4Font := h4Font on:aGC device.
    h5Font := h5Font on:aGC device.
    h6Font := h6Font on:aGC device.

    fixFontWidth := codeFont width.

    "Created: 22.6.1996 / 16:49:01 / cg"
!

header:index font:aFont space:space
    |wasEmpty prevH need|

    self needSpace:fontHeight * space.
    wasEmpty := previousIsEmpty.

    prevH := fontHeight.
    self setFont:aFont.

    self conditionalEmpty.
    self empty:(fontHeight - prevH).

    hBegin notNil ifTrue:[
        'HTML: oops - nested headers' infoPrintNL.
    ].
    hBegin := element.

    (formatting and:[arrayOfHeaderIndex notNil]) ifTrue:[
        arrayOfHeaderIndex size >= index ifTrue:[
            arrayOfHeaderIndex at:index put:((arrayOfHeaderIndex at:index) + 1).
            (index +1) to:arrayOfHeaderIndex size do:[:i| arrayOfHeaderIndex at:i put:0 ].
            headerDefinition := ''
        ]
    ].

    "Modified: 7.9.1996 / 17:15:45 / cg"
!

headerEnd
    |prevH desc|

    self conditionalBreak.
    prevH := fontHeight.
    self setFont:normalFont.
    self empty.

    (headerDefinition notNil 
     and:[hBegin notNil 
     and:[headerDefinition notEmpty]]) 
     ifTrue:[
        listOfHeaders isNil ifTrue:[
            listOfHeaders := OrderedCollection new
        ].
        desc := Array with:(hBegin type asString last digitValue)
                      with:pageNumber
                      with:headerDefinition.

        listOfHeaders add:desc.
    ].

    hBegin := nil.
    headerDefinition := nil.

    "Modified: 7.9.1996 / 17:14:09 / cg"
!

initialHeaderNumbers
    (formattingStyle at:#headerNumbers ifAbsent:false) == true ifTrue:[
        (formattingStyle at:#initialHeaderNumbers ifAbsent:nil) notNil ifTrue:[
            ^ (formattingStyle at:#initialHeaderNumbers) collect:[:n | n - 1]
        ].
        ^ Array new:6 withAll:0.
    ].
    ^ nil

    "Created: 7.9.1996 / 15:34:59 / cg"
!

needSpace:nPixel
    |need|

    destination isView ifFalse:[
        "/
        "/ when printing, force a pageBreak, if not at least nPixel pixels available
        "/
        need := element numericParameterFor:'need' default:nPixel.
        (y + need) > self pageBreakLimit ifTrue:[
            self break.
            previousIsEmpty := true.
            self pageBreak
        ].
    ].


!

romanStringFor:aNumber
    aNumber >= 100 ifTrue:[
        ^ 'C' , (self romanStringFor:aNumber - 100)
    ].
    aNumber >= 50 ifTrue:[
        ^ 'L' , (self romanStringFor:aNumber - 50)
    ].
    aNumber >= 10 ifTrue:[
        ^ 'X' , (self romanStringFor:aNumber - 10)
    ].
    aNumber >= 5 ifTrue:[
        ^ 'V' , (self romanStringFor:aNumber - 5)
    ].
    aNumber >= 1 ifTrue:[
        ^ 'I' , (self romanStringFor:aNumber - 1)
    ].
    ^ ''

    "
     HTMLDocumentPainter new romanStringFor:110  
     HTMLDocumentPainter new romanStringFor:9  
    "

    "Modified: 20.5.1996 / 18:57:20 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
!

startImageDisplayProcess
    imageDisplayProcess :=
        [   |entry i pos x y fg bg|

            [true] whileTrue:[
                "/ if nothing to display - look if there is anything to load

                [imagesToDisplay isEmpty] whileTrue:[
                    imagesToLoad notEmpty ifTrue:[
                        i := imagesToLoad next.
                        i := i on:destination device.
                    ] ifFalse:[
                        imagesToDisplay readSemaphore wait
                    ]
                ].

                "/ load & display

                entry := imagesToDisplay removeLast.
                i := entry at:1.
                pos := entry at:2.
                fg := entry at:3.
                bg := entry at:4.
                i := i on:destination device.

                x := pos x.
                y := pos y.

                ((y+i height) >= displayTop 
                and:[y <= displayBottom
                and:[(x) <= displayRight]]) ifTrue:[
                    destination paint:fg on:bg.
                    destination displayForm:i x:x y:y.
                ]
            ]
        ] newProcess.
    imageDisplayProcess priority:7.
    imageDisplayProcess name:'image load & display [' , Processor activeProcess id printString , ']'.
    imageDisplayProcess resume.

    "Created: 17.6.1996 / 20:53:01 / cg"
    "Modified: 11.7.1996 / 10:44:24 / cg"
! !

!HTMLDocumentPainter methodsFor:'meta commands'!

processMetaCommands
    destination isView ifFalse:[^ self].

    metaCommands notNil ifTrue:[
        metaCommands do:[:entry |
            |metaCmd metaArg args time url p|

            metaCmd := entry key.
            metaArg := entry value.

            Transcript showCR:metaCmd , ' -> ' , metaArg.

            metaCmd = 'refresh' ifTrue:[
                args := metaArg asCollectionOfSubstringsSeparatedBy:$;.
                args size >= 2 ifTrue:[
                    time := Integer readFrom:(args at:1) onError:nil.
                    time notNil ifTrue:[
                        url := HTMLMarkup parameterFor:'URL' from:(args at:2).
                        url notNil ifTrue:[
                            subProcesses isNil ifTrue:[
                                subProcesses := OrderedCollection new.
                            ].
                            p := [
                                    Process terminateSignal handle:[:ex |
                                        subProcesses remove:p ifAbsent:nil      
                                    ] do:[
                                        Delay waitForSeconds:time.
                                        self refreshDocument:url.
                                        Processor activeProcess terminate.
                                    ]    
                                 ] newProcess.
                            p priority:7; name:'HTML meta'.
                            subProcesses add:p.
                            p resume.    
                        ]
                    ].
                ]
            ].
        ]
    ]

    "Created: 22.6.1996 / 16:49:01 / cg"
    "Modified: 5.9.1996 / 21:00:53 / cg"
!

refreshDocument:url
    'HTML: automatic refresh ...' infoPrintCR.

    imageAndStyleResolver
        showDocument:url 
        text:nil
        action:nil
        remember:true
        source:false

    "Created: 22.6.1996 / 16:49:01 / cg"
    "Modified: 5.9.1996 / 21:00:30 / cg"
! !

!HTMLDocumentPainter methodsFor:'queries'!

anchorAt:aPoint
    anchors do:[:a |
        |anchorBounds|

        (anchorBounds := a bounds) notNil ifTrue:[
            anchorBounds do:[:aRectangle |
                (aRectangle containsPoint:aPoint) ifTrue:[
                    ^ a
                ]
            ]
        ]
    ].
    ^ nil

    "Created: 22.6.1996 / 16:49:01 / cg"
    "Modified: 5.9.1996 / 23:30:12 / cg"
!

height
    maxHeight isNil ifTrue:[^ 0].
    ^ maxHeight

    "Modified: 21.5.1996 / 15:24:02 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
!

positionOfAnchor:aLocalAnchor
    |nm|

    anchors do:[:a |
        |anchorBounds|

        nm := a nameString.
        nm = aLocalAnchor ifTrue:[
            (anchorBounds := a bounds) notNil ifTrue:[
                anchorBounds do:[:aRectangle |
                    ^ aRectangle origin
                ]
            ].
            ^ nil
        ]
    ].
    ^ nil

    "Created: 22.6.1996 / 16:49:01 / cg"
    "Modified: 5.9.1996 / 22:41:04 / cg"
!

width
    maxWidth isNil ifTrue:[^ 0].
    ^ maxWidth

    "Modified: 21.5.1996 / 15:24:09 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
! !

!HTMLDocumentPainter methodsFor:'style changes'!

setFont:aFont
    aFont ~~ currentFont ifTrue:[
        currentFont := aFont on:destination device.

        fontAvgHeight := currentFont height.
        fontHeight := currentFont maxHeight.
        fontAscent := currentFont maxAscent.
        wSpace     := currentFont widthOf:' '.
        needFontChange := true.
    ]

    "Created: 22.6.1996 / 16:49:01 / cg"
    "Modified: 5.9.1996 / 22:42:56 / cg"
! !

!HTMLDocumentPainter methodsFor:'widgets'!

createAppletFor:element
    |v wWant hWant w h sp clsName url cls|

    (v := element view) isNil ifTrue:[
        wWant := element numericParameterFor:'WIDTH'.
        hWant := element numericParameterFor:'HEIGHT'.

        wWant isNil ifTrue:[^ self].
        hWant isNil ifTrue:[^ self].
    ] ifFalse:[
        w := v width.
        h := v height.
    ].

    clsName := element parameterFor:'CLASS'.
    clsName isNil ifTrue:[^ self].

    url := element parameterFor:'URL'.
    url isNil ifTrue:[
        "/ the class must be already in the image ..
        cls := Smalltalk classNamed:clsName.
    ] ifFalse:[
        cls := self loadAppletClass:clsName fromURL:url
    ].
    cls isNil ifTrue:[
        ('HTML: applet class not found/loadable: ' , clsName) infoPrintCR
    ] ifFalse:[
        v := cls in:destination.
        element view:v.
        widgets add:element.
    ]

    "Modified: 18.6.1996 / 21:47:57 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
!

createWidgetFor:element inForm:aForm
    |typeString widget sz nameString valueString holder theForm max
     checked rows cols clr|

    (widget := element view) notNil ifTrue:[
        ^ widget
    ].

    destination isView ifFalse:[^ nil].

    theForm := aForm.

    aForm isNil ifTrue:[
        'HTML: input field not within form' infoPrintNL.
        ^ nil
    ].

    sz := element sizeValue.
    nameString := element nameString.
    valueString := element valueString.

    element type == #textarea ifTrue:[
        typeString := element type
    ] ifFalse:[
        typeString := element typeString.
        typeString notNil ifTrue:[
            typeString := typeString asLowercase
        ]
    ].

    typeString = 'submit' ifTrue:[
        widget := Button label:valueString in:destination.
        widget font:normalFont.
"/                    widget backgroundColor:(destination viewBackground).
        widget action:[self formSubmitted:theForm].
    ].

    typeString = 'reset' ifTrue:[
        widget := Button label:valueString in:destination.
        widget font:normalFont.
"/                    widget backgroundColor:(destination viewBackground).
        widget action:[self formResetted:theForm].
    ].

    typeString = 'textarea' ifTrue:[
        rows := element numericParameterFor:'ROWS' default:5.
        cols := element numericParameterFor:'COLS' default:40.
        widget := HVScrollableView for:EditTextView miniScrollerH:true in:destination.
        widget viewBackground:(destination viewBackground).
        widget scrollBar viewBackground:(destination viewBackground).
        widget horizontalScrollBar viewBackground:(destination viewBackground).
        (rows notNil and:[cols notNil]) ifTrue:[
            widget extent:(widget preferredExtentForLines:rows cols:cols)
        ].
        clr := EditField new backgroundColor.
        widget scrolledView backgroundColor:clr.
    ].

    typeString = 'checkbox' ifTrue:[
        checked := element hasParameterFor:'CHECKED' orLowerCase:'checked'.
        holder := checked asValue.
        aForm valueAt:nameString put:holder.

        widget := CheckToggle in:destination.
        widget model:holder.
    ].

    typeString = 'radio' ifTrue:[
        widget := RadioButton in:destination.
    ].

    typeString = 'hidden' ifTrue:[
"/        widget := View new.
    ].

    widget isNil ifTrue:[
        "/ inputField
"/                                    sz isNil ifTrue:[
"/                                        sz := 10
"/                                    ].
        valueString notNil ifTrue:[
            sz notNil ifTrue:[    
                valueString := valueString copyTo:(sz min:valueString size).
            ].
            holder := valueString asValue
        ] ifFalse:[
            holder := '' asValue.
        ].    
        nameString notNil ifTrue:[
            aForm valueAt:nameString put:holder.
        ].

        widget := EditField in:destination.
        sz notNil ifTrue:[
            widget maxChars:sz.
            widget width:(normalFont widthOf:'O') * sz.
        ].
        widget font:normalFont.
        widget model:holder.
        widget immediateAccept:true.
        typeString = 'password' ifTrue:[
            widget passwordCharacter:$*
        ]
    ].

    aForm addWidget:element.

    widget notNil ifTrue:[
        (max := aForm maxHeight) isNil ifTrue:[
            max := 0
        ].
        aForm maxHeight:(max max:(widget height)).

        widget beInvisible.
        element view:widget.
        widgets isNil ifTrue:[
            widgets := OrderedCollection new.
        ].
        widgets add:element.
    ].

    ^ widget

    "Created: 22.6.1996 / 16:49:01 / cg"
    "Modified: 5.9.1996 / 11:38:48 / cg"
!

destroyWidgets
    widgets notNil ifTrue:[
        widgets do:[:widget | widget view destroy].
        widgets := nil.
    ].

    "Modified: 21.5.1996 / 16:01:01 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
!

fixupForm:aForm
    |submit theForm
     widgets v inputFields anyInputFields anyOtherWidgets group
     rGroups rGroup|

    "/ fixup the form: if there is a single inputField,
    "/ let its return submitt.
    (widgets := aForm widgets) notNil ifTrue:[

        theForm := aForm.

        submit := nil.
        anyOtherWidgets := anyInputFields := false.
        inputFields := OrderedCollection new.
        group := EnterFieldGroup new.

        widgets do:[:aWidget |
            aWidget typeString = 'submit' ifTrue:[
                submit := aWidget
            ] ifFalse:[
                (v := aWidget view) notNil ifTrue:[
                    v isInputField ifTrue:[
                        group add:v.
                        anyInputFields := true.
                    ] ifFalse:[
                        aWidget typeString = 'radio' ifTrue:[
                            rGroups isNil ifTrue:[
                                rGroups := Dictionary new.
                            ].
                            rGroup := rGroups at:(aWidget nameString) ifAbsent:nil.
                            rGroup isNil ifTrue:[
                                rGroup := RadioButtonGroup new.
                                rGroups at:(aWidget nameString) put:rGroup
                            ].
                            rGroup add:v.
                            (aWidget hasParameterFor:'CHECKED' orLowerCase:'checked')
                            ifTrue:[
                                rGroup value:(rGroup size)
                            ]
                        ].
                        anyOtherWidgets := true
                    ]
                ]
            ]
        ].

        submit isNil ifTrue:[
            anyOtherWidgets ifFalse:[
                anyInputFields ifTrue:[
                    group leaveAction:[self formSubmitted:theForm]   
                ]    
            ]
        ] ifFalse:[
            "/ mhmh - if there are only inputFields,
            "/ let the last trigger ....

            anyOtherWidgets ifFalse:[
                anyInputFields ifTrue:[
                    group leaveAction:[
                        submit view turnOn.
                        destination device flush.
                        self formSubmitted:theForm.
                        submit view turnOff.
                    ]
                ]
            ]
        ].

        "/ let user click into the field to get focus
        "/ (no automatic focus on the first field)
        group makeInactive.

        rGroups notNil ifTrue:[
            rGroups keysAndValuesDo:[:nm :group |
                aForm valueAt:nm put:group valueChannel
            ]
        ]
    ]

    "Modified: 23.5.1996 / 09:18:16 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
!

formSubmitted:aFormElement
    |info hRef method encType attrs|

    hRef := aFormElement actionString.
    method := aFormElement methodString.
    encType := aFormElement encTypeString.

    info := IdentityDictionary new.
    info at:#href put:hRef.
    info at:#method put:method.
    info at:#encType put:encType.

    attrs := Dictionary new.
    aFormElement values keysAndValuesDo:[:name :holder |
        attrs at:name put:holder value
    ].
    info at:#attributes put:attrs.

"/  'submit: ' print. info printCR.

    destination submitForm:info.

    "Modified: 21.5.1996 / 23:37:14 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
!

hideAllWidgets
    "hide any widget"

    |any|

    widgets notNil ifTrue:[
        any := false.

        widgets do:[:widget | 
            |v|

            v := widget view.
            v notNil ifTrue:[
                v realized ifTrue:[
                    v beInvisible.
                ]
            ]
        ].
        any ifTrue:[
            destination device flush.
        ]
    ]

    "Modified: 22.5.1996 / 17:53:37 / cg"
    "Created: 22.6.1996 / 16:49:01 / cg"
!

hideWidgets
    "hide any widget which became invisible"

    |any dH|

    widgets notNil ifTrue:[
        any := false.
        dH := destination height.

        widgets do:[:widget | 
            |bounds v vOrg org corner|

            bounds := widget bounds.
            bounds notNil ifTrue:[
                v := widget view.
                v notNil ifTrue:[
                    v realized ifTrue:[
                        vOrg := destination viewOrigin.
                        org := bounds origin - vOrg.
                        corner := bounds corner - vOrg.

                        (org y > dH
                        or:[corner y < 0]) ifTrue:[
                            any ifFalse:[
                                destination device flush.
                                destination sensor ignoreExposeEvents:true.
                                any := true.
                            ].
                            v beInvisible.
"/ 'u' printCR.
"/ Delay waitForSeconds:1.
                        ] ifFalse:[
                            v origin ~= org ifTrue:[
                                any ifFalse:[
                                    destination device flush.
                                    destination sensor ignoreExposeEvents:true.
                                    any := true.
                                ].
"/ 'mv' printCR.
                                v origin:org.
"/ Delay waitForSeconds:1.
                            ]
                        ].
                    ]
                ]
            ]
        ].
        any ifTrue:[
            destination device flush.
            destination sensor ignoreExposeEvents:false.
        ]
    ]

    "Modified: 22.5.1996 / 17:53:37 / cg"
    "Created: 22.6.1996 / 16:49:02 / cg"
!

loadAppletClass:clsName fromURL:url
    ^ nil

    "Created: 22.6.1996 / 16:49:02 / cg"
!

prescanForm:aForm atIndex:startIndex
    "prescan a form, for its widgets max height.
     a kludge - we need the form elements' heights BEFORE
     formatting (since the text-elements have no origin knowledge,
     which could be backpatched (also, we needed a way to break
     MarkupText into multiple individual text items"

    |index endIndex element type|

    index := startIndex+1.
    endIndex := document size.

    [index <= endIndex] whileTrue:[
        element := document at:index.
        type := element type.
        type == #'/form' ifTrue:[^ self].

        type == #form ifTrue:[
            'HTML: unterminated form' infoPrintNL.
            ^ self
        ].
        type == #input ifTrue:[
            self createWidgetFor:element inForm:aForm
        ].
        type == #textarea ifTrue:[
            self createWidgetFor:element inForm:aForm
        ].

        index := index + 1.
    ].

    "Modified: 18.6.1996 / 21:13:53 / cg"
    "Created: 22.6.1996 / 16:49:02 / cg"
!

prescanForms
    "a kludge - we need the form elements' heights BEFORE
     formatting (since the text-elements have no origin knowledge,
     which could be backpatched (also, we needed a way to break
     MarkupText into multiple individual text items"

    document keysAndValuesDo:[:index :element |
        |type|

        (type := element type) == #form ifTrue:[
            self prescanForm:element atIndex:index
        ].
        ((type == #app) or:[type == #applet]) ifTrue:[
            self createAppletFor:element
        ].
    ]

    "Created: 22.6.1996 / 16:49:02 / cg"
    "Modified: 11.7.1996 / 14:28:11 / cg"
!

showWidgets
    "show any widget which became visible"

    |dH|

    widgets notNil ifTrue:[
        dH := destination height.

        widgets do:[:widget | 
            |bounds v vOrg org corner|

            bounds := widget bounds.
            bounds notNil ifTrue:[
                v := widget view.
                v notNil ifTrue:[
                    v realized ifFalse:[
                        vOrg := destination viewOrigin.
                        org := bounds origin - vOrg.
                        corner := bounds corner - vOrg.

                        (corner y >= 0
                        and:[org y <= dH]) ifTrue:[
"/ Transcript show:'map '; showCR:v class name.                                
                            v origin:org.
                            v beVisible
                        ] ifFalse:[
"/ Transcript show:v class name; show:' at: '; show:org; showCR:' invisible'.                               
                        ].
                    ] ifTrue:[
"/ Transcript show:v class name; showCR:' already mapped'
                    ]
                ]
            ]
        ].
    ]

    "Modified: 22.5.1996 / 17:54:04 / cg"
    "Created: 22.6.1996 / 16:49:02 / cg"
! !

!HTMLDocumentPainter  class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic3/Attic/HTMLDocumentPainter.st,v 1.77 1996-09-10 13:47:11 ca Exp $'
! !
HTMLDocumentPainter initialize!
